Select
Bootstrap Select
Bootstrap Material Select is a form control that, after a click displays a collapsable list of multiple values which can be used in forms, menus or surveys.
MDB provides you a variety of options and variations.
Default select
Custom select
menus need only a custom class, .custom-select to trigger the
custom
styles. Custom styles are limited to the select
’s initial appearance and cannot modify the
option
's
due to
browser limitations.
<select class="browser-default custom-select">
<option selected>Open this select menu</option>
<option value="1">One</option>
<option value="2">Two</option>
<option value="3">Three</option>
</select>
Material select MDB Pro component
Material Select
requires an initialization. You have to add the
.materialSelect()
js code to the
select
element.
<select class="mdb-select md-form">
<option value="" disabled selected>Choose your option</option>
<option value="1">Option 1</option>
<option value="2">Option 2</option>
<option value="3">Option 3</option>
</select>
// Material Select Initialization
$(document).ready(function() {
$('.mdb-select').materialSelect();
});
You may also choose from small and large custom selects to match our similarly sized text inputs.
<select class="browser-default custom-select custom-select-lg mb-3">
<option selected>Open this select menu</option>
<option value="1">One</option>
<option value="2">Two</option>
<option value="3">Three</option>
</select>
<select class="custom-select custom-select-sm">
<option selected>Open this select menu</option>
<option value="1">One</option>
<option value="2">Two</option>
<option value="3">Three</option>
</select>
The multiple
attribute is also supported:
<select class="custom-select" multiple>
<option selected>Open this select menu</option>
<option value="1">One</option>
<option value="2">Two</option>
<option value="3">Three</option>
</select>
As is the size
attribute:
<select class="custom-select" size="3">
<option selected>Open this select menu</option>
<option value="1">One</option>
<option value="2">Two</option>
<option value="3">Three</option>
</select>
Overwriting a standard select
MDB overwrites a standard select to replace it with our Material Select. That's why before you can use it, you have to initialize Material Select by placing the following code in your project.
In addition, you will need a separate call for any dynamically generated select elements your page generates.
Initialization:
// Material Select Initialization
$(document).ready(function() {
$('.mdb-select').materialSelect();
});
Color variations MDB Pro component
<!--Blue select-->
<select class="mdb-select md-form colorful-select dropdown-primary">
<option value="1">Option 1</option>
<option value="2">Option 2</option>
<option value="3">Option 3</option>
<option value="4">Option 4</option>
<option value="5">Option 5</option>
</select>
<label class="mdb-main-label">Blue select</label>
<!--/Blue select-->
// Material Select Initialization
$(document).ready(function() {
$('.mdb-select').materialSelect();
});
In order to change a select color use one of the following classes:
1.
.dropdown-primary
2.
.dropdown-danger
3.
.dropdown-default
4.
.dropdown-secondary
5.
.dropdown-success
6.
.dropdown-info
7.
.dropdown-warning
8.
.dropdown-ins
9.
.dropdown-dark
Select with a search box MDB Pro component
<select class="mdb-select md-form" searchable="Search here..">
<option value="" disabled selected>Choose your country</option>
<option value="1">USA</option>
<option value="2">Germany</option>
<option value="3">France</option>
<option value="3">Poland</option>
<option value="3">Japan</option>
</select>
// Material Select Initialization
$(document).ready(function() {
$('.mdb-select').materialSelect();
});
Select with a label and search box MDB Pro component
<select class="mdb-select md-form" searchable="Search here..">
<option value="" disabled selected>Choose your country</option>
<option value="1">USA</option>
<option value="2">Germany</option>
<option value="3">France</option>
<option value="3">Poland</option>
<option value="3">Japan</option>
</select>
<label class="mdb-main-label">Label example</label>
// Material Select Initialization
$(document).ready(function() {
$('.mdb-select').materialSelect();
});
Select with a secondary text MDB Pro component
<select class="mdb-select md-form" searchable="Search here..">
<option value="" disabled selected>Choose your car</option>
<option value="2" data-secondary-text="Production year: 2012">Volkswagen Passat</option>
<option value="3" data-secondary-text="Production year: 2017">Subaru Legacy</option>
<option value="3" data-secondary-text="Production year: 2015">Hyundai Elantra</option>
<option value="3" data-secondary-text="Production year: 2019">Honda Civic</option>
<option value="3" data-secondary-text="Production year: 2016">Audi A6</option>
</select>
// Material Select Initialization
$(document).ready(function() {
$('.mdb-select').materialSelect();
});
Multiple select MDB Pro component
<select class="mdb-select md-form" multiple>
<option value="" disabled selected>Choose your option</option>
<option value="1">Option 1</option>
<option value="2">Option 2</option>
<option value="3">Option 3</option>
</select>
<label class="mdb-main-label">Example label</label>
<button class="btn-save btn btn-primary btn-sm">Save</button>
// Material Select Initialization
$(document).ready(function() {
$('.mdb-select').materialSelect();
});
Multiselect variations
More multiselect examples and variations can be found in the Multiselect documentation
Options groups MDB Pro component
<select class="mdb-select md-form">
<optgroup label="team 1">
<option value="1">Option 1</option>
<option value="2">Option 2</option>
</optgroup>
<optgroup label="team 2">
<option value="3">Option 3</option>
<option value="4">Option 4</option>
</optgroup>
</select>
<label class="mdb-main-label">Example label</label>
// Material Select Initialization
$(document).ready(function() {
$('.mdb-select').materialSelect();
});
Select with icons MDB Pro component
<select class="mdb-select md-form">
<option value="" disabled selected>Choose your option</option>
<option value="" data-icon="https://mdbootstrap.com/img/Photos/Avatars/avatar-1.jpg" class="rounded-circle">
example
1</option>
<option value="" data-icon="https://mdbootstrap.com/img/Photos/Avatars/avatar-2.jpg" class="rounded-circle">
example
2</option>
<option value="" data-icon="https://mdbootstrap.com/img/Photos/Avatars/avatar-3.jpg" class="rounded-circle">
example
1</option>
</select>
<label class="mdb-main-label">Example label</label>
// Material Select Initialization
$(document).ready(function() {
$('.mdb-select').materialSelect();
});
Disabled select MDB Pro component
By adding a disabled
attribute to the select (or a particular option), you can make it unselectable.
<!-- Disabled select-->
<select class="mdb-select md-form" disabled>
<option value="" disabled selected>Choose your option</option>
<option value="1">Option 1</option>
<option value="2">Option 2</option>
<option value="3">Option 3</option>
</select>
<label class="disabled mdb-main-label">Example label</label>
<!--Disabled option-->
<select class="mdb-select md-form">
<option value="" disabled selected>Choose your option</option>
<option value="1" disabled>Disabled option</option>
<option value="2">Option 2</option>
<option value="3">Option 3</option>
</select>
<label class="mdb-main-label">Example label</label>
// Material Select Initialization
$(document).ready(function() {
$('.mdb-select').materialSelect();
});
Outline select MDB Pro component
Note warning: For now, an outline styling works correct only for Material Select (not Multiselect) with primary dropdown menu and with skins colors.
<div class="row">
<div class="col-md-6 select-outline">
<select class="mdb-select md-form md-outline colorful-select dropdown-primary">
<option value="" disabled selected>Choose your option</option>
<option value="1">Option 1</option>
<option value="2">Option 2</option>
<option value="3">Option 3</option>
</select>
<label>Example label</label>
</div>
</div>
.md-outline.select-wrapper+label {
top: .5em !important;
z-index: 2 !important;
}
// Material Select Initialization
$(document).ready(function() {
$('.mdb-select').materialSelect();
$('.select-wrapper.md-form.md-outline input.select-dropdown').bind('focus blur', function () {
$(this).closest('.select-outline').find('label').toggleClass('active');
$(this).closest('.select-outline').find('.caret').toggleClass('active');
});
});
Updating/destroying Material Select MDB Pro component
To update the items inside the existing Material Select you can destroy it with the function below and then initialize it again.
// Material Select Destroy
$('.mdb-select').materialSelect({
destroy: true
});
Adding new options MDB Pro component
By adding an editable="true"
attribute to the select, you can easily extend the options list.
<select class="mdb-select md-form" editable="true" searchable="Search and add here...">
<option value="" disabled selected>Choose your option</option>
<option value="1">Option 1</option>
<option value="2">Option 2</option>
<option value="3">Option 3</option>
</select>
<label class="mdb-main-label">Example label</label>
$(document).ready(function() {
// Material Select
$('.mdb-select').materialSelect({
});
})
Validation MDB Pro component
<form class="needs-validation" novalidate>
<select class="mdb-select validate md-form" searchable="Search here..">
<option value="" disabled selected>Choose your country</option>
<option value="1">USA</option>
<option value="2">Germany</option>
<option value="3">France</option>
<option value="4">Poland</option>
<option value="5">Japan</option>
</select>
<button class="btn btn-default btn-sm">Submit</button>
</form>
$(document).ready(function() {
$('.mdb-select.validate').materialSelect({
validate: true,
labels: {
validFeedback: 'Correct choice',
invalidFeedback: 'Wrong choice'
}
});
function validateSelect(e) {
e.preventDefault();
$('.needs-validation').addClass('was-validated');
if ($('.needs-validation select').val() === null) {
$('.needs-validation').find('.valid-feedback').hide();
$('.needs-validation').find('.invalid-feedback').show();
$('.needs-validation').find('.select-dropdown').val('').prop('placeholder', 'No countries selected')
} else {
$('.needs-validation').find('.valid-feedback').show();
$('.needs-validation').find('.invalid-feedback').hide();
}
}
$('.needs-validation select').on('change', e => validateSelect(e))
$('.needs-validation').on('submit', e => validateSelect(e))
});
Select options and attributes MDB Pro component
There is a plenty of options to customize the Material Select. All of them are described below.
Important thing to note is that data attributes have higher priority than JS options passed to the .materialSelect()
call.
It means that if you will have data-placeholder="Please select a country"
and JS option { placeholder: 'Choose country' }
, then the value of data-placeholder
will be displayed as it has higher priority.
The exception is the id
attribute which has higher priority than data-select-id
as described below.
Data attribute | Option name | Type | Default | Description |
---|---|---|---|---|
- | destroy | boolean | false | If set to true destroys the Material Select wrapper |
data-secondary-text | secondaryText | string | false | Additional text displayed inside an option |
data-validate | validate | boolean | false | If set to true the select control will be validated when put into form element |
data-select-id | selectId | string | null | If provided, this ID will be used instead of a random UUID to make Material Select elements unique. Note: if id attribute is provided, it has the highest priority |
data-default-material-input | defaultMaterialInput | boolean | false | If set to true the select control will look like default Bootstrap select |
data-fas-classes | fasClasses | string | empty | Space-separated list of FAS classes to add on the <i> element in the options list. Note: works only if data-fas attribute is provided with chosen FAS class value |
data-far-classes | farClasses | string | empty | Space-separated list of FAR classes to add on the <i> element in the options list. Note: works only if data-far attribute is provided with chosen FAR class value |
data-fab-classes | fabClasses | string | empty | Space-separated list of FAB classes to add on the <i> element in the options list. Note: works only if data-fab attribute is provided with chosen FAB class value |
data-copy-classes-option | copyClassesOption | boolean | false | If set to true all classes added to the native <select> control will be copied to each option in the Material Select dropdown |
data-label-select-all | labels.selectAll | string | Select all | The text which is displayed as option which selects all other options in the Multiselect |
data-label-options-selected | labels.optionsSelected | string | options selected | The text which is displayed on the Multiselect when there are more than 5 (default) options selected, e.g. 7 options selected |
data-label-valid-feedback | labels.validFeedback | string | Ok | The text which is displayed below the Material Select when the validate option is enabled and the select is valid |
data-label-invalid-feedback | labels.invalidFeedback | string | Incorrect value | The text which is displayed below the Material Select when the validate option is enabled and the select is invalid |
data-label-no-search-results | labels.noSearchResults | string | No results | The text which is displayed in the Searchable Select when there are no results |
data-label-keyboard-active-class | keyboardActiveClass | string | heavy-rain-gradient | The class which is added to the options selected by the arrow keys (using keyboard) |
data-placeholder | placeholder | string | null | The placeholder text which is displayed on the select if no value selected yet |
data-visible-options | visibleOptions | number | 5 | The maximum number of options which are visible in the Material Select dropdown without scrolling. If set to -1 , the limit is off |
data-max-selected-options | maxSelectedOptions | number | 5 | The maximum number of comma-separated list of options displayed on the Multiselect. If a user selects more options than that value, the X options selected text will be displayed instead. If set to -1 , the limit is off |
Getting started: download & setup
Download
All of the components and features are a part of the MDBootstrap package.
MDBootstrap (Material Design for Bootstrap) is an MIT Licensed framework - free for personal & commercial use.
It combines the esthetic of Material Design and the functionalities of the newest Bootstrap.
Click on the button below to visit the Getting Started Page, where you can download the latest MDBootstrap package.
MDBootstrap Download MDBootstrap AboutMDB Pro
Using components and features labeled as MDB Pro component requires the MDB Pro package - a powerful UI Kit containing over 5,000 components, dozens of plugins and much more cool features.
Click the button below to learn more about the MDBootstrap Pro package.
MDBootstrap ProTutorials
If you need any additional help, use our "5 min Quick Start" guide or start full Bootstrap tutorial.
5 min Quick Start Full Bootstrap TutorialCompilation & Customization
To reduce the weight of MDBootstrap package even more, you can compile your own, custom package containing only those components and features that you need.
If you need additional help with compiling your custom package, please use our Compilation & Customization tutorial.
Compilation & Customization tutorialMap of dependencies of SCSS files in MDBootstrap:
Legend:
'-->' means 'required'
All free and pro files require files from 'core' catalog
'none' means 'this component doesn't require anything except core files'
A file wrapped by `< >` means that this file make the base component prettier but it isn't necessary for the proper working
All PRO components require 'pro/_variables.scss' file
scss/
|
|-- core/
| |
| |-- bootstrap/
| | |-- _functions.scss
| | |-- _variables.scss
| |
| |-- _colors.scss
| |-- _global.scss
| |-- _helpers.scss
| |-- _masks.scss
| |-- _mixins.scss
| |-- _typography.scss
| |-- _variables.scss
| |-- _waves.scss
|
|-- free/
| |-- _animations-basic.scss --> none
| |-- _animations-extended.scss --> _animations-basic.scss
| |-- _buttons.scss --> none
| |-- _cards.scss --> none <_buttons.scss>
| |-- _dropdowns.scss --> none <_buttons.scss>
| |-- _input-group.scss --> _forms.scss, _buttons.scss, _dropdowns.scss
| |-- _navbars.scss --> none <_buttons.scss, _forms.scss, _input-group.scss>
| |-- _pagination.scss --> none
| |-- _badges.scss --> none
| |-- _modals.scss --> _buttons.scss, _forms.scss (PRO --> _tabs.scss)
| |-- _carousels.scss --> <_buttons.scss>
| |-- _forms.scss --> none
| |-- _msc.scss --> none <_buttons.scss, _forms.scss, _cards.scss>
| |-- _footers.scss none <_buttons.scss> (PRO: )
| |-- _list-group.scss --> none
| |-- _tables.scss --> none (PRO: _material-select.scss, pro/_forms.scss, _checkbox.scss, pro/_buttons.scss, pro/_cards.scss, _pagination.scss, pro/_msc.scss)
| |-- _depreciated.scss
|
|-- pro/
| |
| |-- picker/
| | |-- _default.scss --> none
| | |-- _default-time.scss --> _default.scss, free/_forms.scss, free/_buttons.scss, pro/_buttons.scss, free/_cards.scss
| | |-- _default-date.scss --> _default.scss, free/_forms.scss
| |
| |-- sections/
| | |-- _templates.scss --> _sidenav.scss
| | |-- _social.scss --> free/_cards.scss, free/ _forms.scss, free/_buttons.scss, pro/_buttons.scss,
| | |-- _team.scss --> free/_buttons.scss, pro/_buttons.scss, free/_cards.scss, pro/_cards.scss
| | |-- _testimonials.scss --> free/_carousels.scss, pro/_carousels.scss, free/_buttons.scss, pro/_buttons.scss
| | |-- _magazine.scss --> _badges.scss
| | |-- _pricing.scss --> free/_buttons.scss, pro/_buttons.scss
| | |-- _contacts.scss --> free/_forms.scss, pro/_forms.scss, free/_buttons.scss, pro/_buttons.scss
| |
| |-- _variables.scss
| |-- _buttons.scss --> free/_buttons.scss, pro/_msc.scss, _checkbox.scss, _radio.scss
| |-- _social-buttons.scss --> free/_buttons.scss, pro/_buttons.scss
| |-- _tabs.scss --> _cards.scss
| |-- _cards.scss --> free/_cards.scss <_buttons.scss, _social-buttons.scss>
| |-- _dropdowns.scss --> free/_dropdowns.scss, free/_buttons.scss
| |-- _navbars.scss --> free/_navbars.scss (PRO: )
| |-- _scrollspy.scss --> none
| |-- _lightbox.scss --> none
| |-- _chips.scss --> none
| |-- _msc.scss --> none
| |-- _forms.scss --> none
| |-- _radio.scss --> none
| |-- _checkbox.scss --> none
| |-- _material-select.scss --> none
| |-- _switch.scss --> none
| |-- _file-input.scss --> free/_forms.scss, free/_buttons.scss
| |-- _range.scss --> none
| |-- _input-group.scss --> free/_input-group.scss and the same what free input group, _checkbox.scss, _radio.scss
| |-- _autocomplete.scss --> free/_forms.scss
| |-- _accordion.scss --> pro/_animations.scss, free/_cards.scss
| |-- _parallax.scss --> none
| |-- _sidenav.scss --> free/_forms.scss, pro/_animations.scss, sections/_templates.scss
| |-- _ecommerce.scss --> free/_cards.scss, pro/_cards.scss, free/_buttons.scss, pro/_buttons.scss, pro/_msc.scss
| |-- _carousels.scss --> free/_carousels.scss, free/_cards.scss, free/_buttons.scss
| |-- _steppers.scss --> free/_buttons.scss
| |-- _blog.scss --> none
| |-- _toasts.scss --> free/_buttons.scss
| |-- _animations.scss --> none
| |-- _charts.scss --> none
| |-- _progress.scss --> none
| |-- _scrollbar.scss --> none
| |-- _skins.scss --> none
| |-- _depreciated.scss
|
`-- _custom-skin.scss
`-- _custom-styles.scss
`-- _custom-variables.scss
`-- mdb.scss
Map of dependencies of JavaScript modules in MDBootstrap:
Legend:
'-->' means 'required'
All files require jQuery and bootstrap.js
js/
├── dist/
│ ├── buttons.js
│ ├── cards.js
│ ├── character-counter.js
│ ├── chips.js
│ ├── collapsible.js --> vendor/velocity.js
│ ├── dropdown.js --> Popper.js, jquery.easing.js
│ ├── file-input.js
│ ├── forms-free.js
│ ├── material-select.js --> dropdown.js
│ ├── mdb-autocomplete.js
│ ├── preloading.js
│ ├── range-input.js --> vendor/velocity.js
│ ├── scrolling-navbar.js
│ ├── sidenav.js --> vendor/velocity.js, vendor/hammer.js, vendor/jquery.hammer.js
│ └── smooth-scroll.js
├── _intro-mdb-pro.js
├── modules.js
├── src/
│ ├── buttons.js
│ ├── cards.js
│ ├── character-counter.js
│ ├── chips.js
│ ├── collapsible.js --> vendor/velocity.js
│ ├── dropdown.js --> Popper.js, jquery.easing.js
│ ├── file-input.js
│ ├── forms-free.js
│ ├── material-select.js --> dropdown.js
│ ├── mdb-autocomplete.js
│ ├── preloading.js
│ ├── range-input.js --> vendor/velocity.js
│ ├── scrolling-navbar.js
│ ├── sidenav.js --> vendor/velocity.js, vendor/hammer.js, vendor/jquery.hammer.js
│ └── smooth-scroll.js
└── vendor/
├── addons/
│ ├── datatables.js
│ └── datatables.min.js
├── chart.js
├── enhanced-modals.js
├── hammer.js
├── jarallax.js
├── jarallax-video.js --> vendor/jarallax.js
├── jquery.easing.js
├── jquery.easypiechart.js
├── jquery.hammer.js --> vendor/hammer.js
├── jquery.sticky.js
├── lightbox.js
├── picker-date.js --> vendor/picker.js
├── picker.js
├── picker-time.js --> vendor/picker.js
├── scrollbar.js
├── scrolling-navbar.js
├── toastr.js
├── velocity.js
├── waves.js
└── wow.js
Integrations with Angular, React or Vue
Apart from the standard Bootstrap integration (using jQuery), MDBootstrap also integrates with Angular, React and Vue.
About MDB Angular About MDB React About MDB VueExclusive resources
MDBootstrap is a platform for web creators and MDB packages are only a part of it.
If you sign up you'll gain free access to other useful tools & resources including:
- Community developed components & design projects
- Technical support & community forum
- CLI interface & free project hosting
- Helpful articles & news agregators
...and much more!
Don't hesitate and sign up now!
Sign up now

Select

Angular Bootstrap 5 Select component

Select fields components are used for collecting user provided information from a list of options.


Basic example

Basic example of select component that allows you to choose from a number of options.

        
            
            <mdb-form-control>
              <mdb-select>
                <mdb-option *ngFor="let option of options" [value]="option.value">{{
                  option.label
                }}</mdb-option>
              </mdb-select>
              <label mdbLabel class="form-label">Example label</label>
            </mdb-form-control>
          
        
    
        
            
            import { Component } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              options = [
                { value: '1', label: 'One' },
                { value: '2', label: 'Two' },
                { value: '3', label: 'Three' },
                { value: '4', label: 'Four' },
                { value: '5', label: 'Five' },
                { value: '6', label: 'Six' },
                { value: '7', label: 'Seven' },
                { value: '8', label: 'Eigth' },
              ];
            }
          
        
    

Multiselect

Add [multiple]="true" input to the select element to activate multiple mode.

        
            
            <mdb-form-control>
              <mdb-select [multiple]="true">
                <mdb-select-all-option>Select all</mdb-select-all-option>
                <mdb-option *ngFor="let option of options" [value]="option.value">{{
                  option.label
                }}</mdb-option>
              </mdb-select>
              <label mdbLabel class="form-label">Example label</label>
            </mdb-form-control>
          
        
    
        
            
            import { Component } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              options = [
                { value: '1', label: 'One' },
                { value: '2', label: 'Two' },
                { value: '3', label: 'Three' },
                { value: '4', label: 'Four' },
                { value: '5', label: 'Five' },
                { value: '6', label: 'Six' },
                { value: '7', label: 'Seven' },
                { value: '8', label: 'Eigth' },
              ];
            }
          
        
    

Select with label

It is possible to add select label by creating element with mdbLabel directive and .form-label class.

        
            
            <mdb-form-control>
              <mdb-select>
                <mdb-option *ngFor="let option of options" [value]="option.value">{{
                  option.label
                }}</mdb-option>
              </mdb-select>
              <label mdbLabel class="form-label">Example label</label>
            </mdb-form-control>
          
        
    
        
            
            import { Component } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              options = [
                { value: '1', label: 'One' },
                { value: '2', label: 'Two' },
                { value: '3', label: 'Three' },
                { value: '4', label: 'Four' },
                { value: '5', label: 'Five' },
                { value: '6', label: 'Six' },
                { value: '7', label: 'Seven' },
                { value: '8', label: 'Eigth' },
              ];
            }
          
        
    

Select with placeholder

Use placeholder option to set placeholder for select input. The placeholder will be displayed when input is focused and no option is selected.

        
            
            <mdb-form-control>
              <mdb-select placeholder="Example placeholder">
                <mdb-option *ngFor="let option of options" [value]="option.value">{{
                  option.label
                }}</mdb-option>
              </mdb-select>
            </mdb-form-control>
          
        
    
        
            
            import { Component } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              options = [
                { value: '1', label: 'One' },
                { value: '2', label: 'Two' },
                { value: '3', label: 'Three' },
                { value: '4', label: 'Four' },
                { value: '5', label: 'Five' },
                { value: '6', label: 'Six' },
                { value: '7', label: 'Seven' },
                { value: '8', label: 'Eigth' },
              ];
            }
          
        
    

Disabled select

Add [disabled]="true" input to the select element to disable the component.

        
            
            <mdb-form-control>
              <mdb-select [disabled]="true">
                <mdb-option *ngFor="let option of options" [value]="option.value">{{
                  option.label
                }}</mdb-option>
              </mdb-select>
              <label mdbLabel class="form-label">Example label</label>
            </mdb-form-control>
          
        
    
        
            
            import { Component } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              options = [
                { value: '1', label: 'One' },
                { value: '2', label: 'Two' },
                { value: '3', label: 'Three' },
                { value: '4', label: 'Four' },
                { value: '5', label: 'Five' },
                { value: '6', label: 'Six' },
                { value: '7', label: 'Seven' },
                { value: '8', label: 'Eigth' },
              ];
            }
          
        
    

Disabled options

Use disabled input on option element to disable specific option.

        
            
            <mdb-form-control>
              <mdb-select>
                <mdb-option *ngFor="let option of options" [value]="option.value" [disabled]="option.disabled">{{
                  option.label
                }}</mdb-option>
              </mdb-select>
              <label mdbLabel class="form-label">Example label</label>
            </mdb-form-control>
          
        
    
        
            
            import { Component } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              options = [
                { value: '1', label: 'One', disabled: false },
                { value: '2', label: 'Two', disabled: true },
                { value: '3', label: 'Three', disabled: true },
                { value: '4', label: 'Four', disabled: false },
                { value: '5', label: 'Five', disabled: true },
                { value: '6', label: 'Six', disabled: false },
                { value: '7', label: 'Seven', disabled: false },
                { value: '8', label: 'Eigth', disabled: false },
              ];
            }
          
        
    

Clear button

Set clearButton option to true to display the button that will allow to clear current selections.

        
            
            <mdb-form-control>
              <mdb-select [clearButton]="true">
                <mdb-option *ngFor="let option of options" [value]="option.value">{{
                  option.label
                }}</mdb-option>
              </mdb-select>
              <label mdbLabel class="form-label">Example label</label>
            </mdb-form-control>
          
        
    
        
            
            import { Component } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              options = [
                { value: '1', label: 'One' },
                { value: '2', label: 'Two' },
                { value: '3', label: 'Three' },
                { value: '4', label: 'Four' },
                { value: '5', label: 'Five' },
                { value: '6', label: 'Six' },
                { value: '7', label: 'Seven' },
                { value: '8', label: 'Eigth' },
              ];
            }
          
        
    

Custom content

A custom content container with a class .select-custom-content will be displayed at the end of the select dropdown.

        
            
            <mdb-form-control>
              <mdb-select>
                <mdb-option *ngFor="let option of options" [value]="option.value">{{
                  option.label
                }}</mdb-option>
                <div class="select-custom-content">
                  <button class="btn-save btn btn-primary btn-sm">Save</button>
                </div>
              </mdb-select>
              <label mdbLabel class="form-label">Example label</label>
            </mdb-form-control>
          
        
    
        
            
            import { Component } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              options = [
                { value: '1', label: 'One' },
                { value: '2', label: 'Two' },
                { value: '3', label: 'Three' },
                { value: '4', label: 'Four' },
                { value: '5', label: 'Five' },
                { value: '6', label: 'Six' },
                { value: '7', label: 'Seven' },
                { value: '8', label: 'Eigth' },
              ];
            }
          
        
    

Visible options

Use visibleOptions input to change the number of options that will be displayed in the select dropdown without scrolling.

        
            
            <mdb-form-control>
              <mdb-select [visibleOptions]="3">
                <mdb-option *ngFor="let option of options" [value]="option.value">{{
                  option.label
                }}</mdb-option>
              </mdb-select>
              <label mdbLabel class="form-label">Example label</label>
            </mdb-form-control>
          
        
    
        
            
            import { Component } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              options = [
                { value: '1', label: 'One' },
                { value: '2', label: 'Two' },
                { value: '3', label: 'Three' },
                { value: '4', label: 'Four' },
                { value: '5', label: 'Five' },
                { value: '6', label: 'Six' },
                { value: '7', label: 'Seven' },
                { value: '8', label: 'Eigth' },
              ];
            }
          
        
    

Secondary text

Add container with class .option-secondary-text to the specific options to display secondary text.

        
            
            <mdb-form-control>
              <mdb-select>
                <mdb-option *ngFor="let option of options" [value]="option.value" [label]="option.label">{{
                  option.label
                }}
                <span class="option-secondary-text">Secondary text</span>
                </mdb-option>
              </mdb-select>
              <label mdbLabel class="form-label">Example label</label>
            </mdb-form-control>
          
        
    
        
            
            import { Component } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              options = [
                { value: '1', label: 'One' },
                { value: '2', label: 'Two' },
                { value: '3', label: 'Three' },
                { value: '4', label: 'Four' },
                { value: '5', label: 'Five' },
                { value: '6', label: 'Six' },
                { value: '7', label: 'Seven' },
                { value: '8', label: 'Eigth' },
              ];
            }
          
        
    


Option groups

It is possible to group options by using mdb-option-group component.

        
            
            <mdb-form-control>
              <mdb-select>
                <mdb-option-group *ngFor="let group of groups" [label]="group.name">
                  <mdb-option *ngFor="let option of group.options" [value]="option.value">{{
                    option.label
                  }}</mdb-option>
                </mdb-option-group>
              </mdb-select>
              <label mdbLabel class="form-label">Example label</label>
            </mdb-form-control>
          
        
    
        
            
            import { Component } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              groups = [
                {
                  name: 'Label 1',
                  options: [
                    { value: 'first-group-1', label: 'One' },
                    { value: 'first-group-2', label: 'Two' },
                    { value: 'first-group-3', label: 'Three' },
                  ],
                },
                {
                  name: 'Label 2',
                  options: [
                    { value: 'second-group-4', label: 'Four' },
                    { value: 'second-group-5', label: 'Five' },
                    { value: 'second-group-6', label: 'Six' },
                  ],
                },
              ];
            }
          
        
    

Select with icons

Add conatiner with option-icon-container class to the specific option to display option icon.

        
            
            <mdb-form-control>
              <mdb-select>
                <mdb-option *ngFor="let option of options" [value]="option.value">{{
                  option.label
                }}
                <span class="option-icon-container">
                  <img class="option-icon rounded-circle" [src]="option.icon" />
                </span>
                </mdb-option>
              </mdb-select>
              <label mdbLabel class="form-label">Example label</label>
            </mdb-form-control>
          
        
    
        
            
            import { Component } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              options = [
                { value: '1', label: 'One', icon: 'https://mdbootstrap.com/img/Photos/Avatars/avatar-1.webp' },
                { value: '2', label: 'Two', icon: 'https://mdbootstrap.com/img/Photos/Avatars/avatar-2.webp' },
                { value: '3', label: 'Three', icon: 'https://mdbootstrap.com/img/Photos/Avatars/avatar-3.webp' },
                { value: '4', label: 'Four', icon: 'https://mdbootstrap.com/img/Photos/Avatars/avatar-4.webp' },
                { value: '5', label: 'Five', icon: 'https://mdbootstrap.com/img/Photos/Avatars/avatar-5.webp' },
              ];
            }
          
        
    

Validation

Use mdbValidate directive to enable validation styles and mdb-error and mdb-success components to display validation messages.

Note: This example uses MDB Angular Validation. Remember to import MdbValidationModule and ReactiveFormsModule to enable reactive forms validation in Angular.

        
            
        <form [formGroup]="validationForm" (ngSubmit)="onSubmit()" #form="ngForm">
          <mdb-form-control>
            <mdb-select
              mdbValidate
              [clearButton]="true"
              formControlName="select"
              [ngClass]="{
                'mb-3': form.submitted
              }"
            >
              <mdb-option *ngFor="let option of options" [value]="option.value">{{
                option.label
              }}</mdb-option>
            </mdb-select>
            <mdb-error *ngIf="select?.invalid && (select?.dirty || select?.touched)"
              >This value is invalid
            </mdb-error>
            <mdb-success *ngIf="select?.valid && (select?.dirty || select?.touched)"
              >This value is valid
            </mdb-success>
          </mdb-form-control>
          <button class="btn btn-primary btn-sm mt-3" type="submit">Submit</button>
        </form>
        
        
    
        
            
        import { Component } from '@angular/core';
        import { AbstractControl, UntypedFormControl, UntypedFormGroup, Validators } from '@angular/forms';

        @Component({
          selector: 'app-root',
          templateUrl: './app.component.html',
        })
        export class AppComponent {
          validationForm = new UntypedFormGroup({
            select: new UntypedFormControl('1', { validators: Validators.required, updateOn: 'submit' }),
          });
          options = [
            { value: '1', label: 'One' },
            { value: '2', label: 'Two' },
            { value: '3', label: 'Three' },
            { value: '4', label: 'Four' },
            { value: '5', label: 'Five' },
            { value: '6', label: 'Six' },
            { value: '7', label: 'Seven' },
            { value: '8', label: 'Eigth' },
          ];

          get select(): AbstractControl {
            return this.validationForm.get('select');
          }

          onSubmit(): void {
            this.validationForm.markAllAsTouched();
          }
        }
        
        
    

Set value

It is possible to set default value using Angular reactive or template driven forms methods.

Reactive forms

Create new formControl with a value (or array of values in multiselect) to select option with corresponding value.

        
            
              <mdb-form-control>
                <mdb-select [formControl]="selectedValue">
                  <mdb-option *ngFor="let option of options" [value]="option.value">{{
                    option.label
                  }}</mdb-option>
                </mdb-select>
                <label mdbLabel class="form-label">Example label</label>
              </mdb-form-control>
            
        
    
        
            
              import { Component } from '@angular/core';
              import { FormControl } from '@angular/forms';

              @Component({
                selector: 'app-root',
                templateUrl: './app.component.html',
              })
              export class AppComponent {
                selectedValue = new FormControl('4');
                options = [
                  { value: '1', label: 'One' },
                  { value: '2', label: 'Two' },
                  { value: '3', label: 'Three' },
                  { value: '4', label: 'Four' },
                  { value: '5', label: 'Five' },
                  { value: '6', label: 'Six' },
                  { value: '7', label: 'Seven' },
                  { value: '8', label: 'Eigth' },
                ];
              }
            
        
    

Template driven forms

Add a value (or array of values in multiselect) to the ngModel to select option with corresponding value.

        
            
              <mdb-form-control>
                <mdb-select [(ngModel)]="selectedValue">
                  <mdb-option *ngFor="let option of options" [value]="option.value">{{
                    option.label
                  }}</mdb-option>
                </mdb-select>
                <label mdbLabel class="form-label">Example label</label>
              </mdb-form-control>
            
        
    
        
            
              import { Component } from '@angular/core';

              @Component({
                selector: 'app-root',
                templateUrl: './app.component.html',
              })
              export class AppComponent {
                selectedValue = '4';
                options = [
                  { value: '1', label: 'One' },
                  { value: '2', label: 'Two' },
                  { value: '3', label: 'Three' },
                  { value: '4', label: 'Four' },
                  { value: '5', label: 'Five' },
                  { value: '6', label: 'Six' },
                  { value: '7', label: 'Seven' },
                  { value: '8', label: 'Eigth' },
                ];
              }
            
        
    

PAY ONCE

USE FOREVER

Hurry up ⌛ claim exclusive long term passes available only during Cyber Weeks

Select - API


Import

        
            
          import { MdbSelectModule } from 'mdb-angular-ui-kit/select';
          import { FormsModule, ReactiveFormsModule } from '@angular/forms';

          …
          @NgModule ({
            ...
            imports: [MdbSelectModule, FormsModule, ReactiveFormsModule],
            ...
          })
        
        
    

Inputs

Name Type Default Description
ariaLabel string undefined Sets the aria-label attribute for accessibility.
ariaLabelledby string undefined Sets the aria-labelledby attribute for accessibility.
autoSelect boolean false Automatically selects the highlighted option when pressing Tab.
clearButton boolean false Displays a button to clear the current selection.
clearButtonTabindex number 0 Sets the tabindex for the clear button.
compareWith (o1: any, o2: any) => boolean (o1, o2) => o1 === o2 Custom comparison function for option values.
disabled boolean false Disables the select input.
displayedLabels number 5 Maximum number of selected options shown as labels before showing a summary.
dropdownClass string undefined Custom CSS classes for the dropdown container.
dropdownHeight number visibleOptions * optionHeight Sets the dropdown height in pixels.
filter boolean false Shows a filter input for searching options.
filterDebounce number 300 Debounce time in milliseconds for the filter input.
filterFn (option: string, filterValue: string) => boolean (option, filterValue) => option.includes(filterValue) Custom function to filter options.
filterPlaceholder string 'Search...' Placeholder text for the filter input.
highlightFirst boolean true Highlights the first option when the dropdown opens.
inputFilterId string undefined ID for the filter input element (for accessibility).
inputId string undefined ID for the select input element (for accessibility).
multiple boolean false Allows selecting multiple options.
notFoundMsg string 'No results found' Message shown when no options match the filter.
optionHeight number 38 Height of a single option in pixels.
optionsSelectedLabel string 'options selected' Text shown when multiple options are selected and summarized.
placeholder string '' Placeholder text for the select input.
required boolean false Marks the select field as required.
size 'sm' | 'lg' | 'default' 'default' Sets the size of the select input.
sortComparator (a: MdbOptionComponent, b: MdbOptionComponent, options: MdbOptionComponent[]) => number undefined Custom sorting function for selected options.
tabindex number 0 Tab index for the select input element.
value any undefined Sets the value of the select input.
visibleOptions number 5 Number of options visible in the dropdown list.

Outputs

Name Type Description
closed EventEmitter<void> Event fired when the select is closed.
opened EventEmitter<void> Event fired when the select is opened.
valueChange EventEmitter<any> Event fired when the select value is changed. It returns single value for single select and an array for multiple select.
search EventEmitter<string> Event fired when the filter input value changes. Emits the current search string.
selected EventEmitter<MdbOptionComponent> Event fired when a value is selected in the select field. It returns only the values selected during the event (unlike valueChange event, which returns all selected values). The event can return a single value or an array if multiple values are selected simultaneously.
deselected EventEmitter<MdbOptionComponent | MdbOptionComponent[]> Event fired when a value is deselected in the select field. It returns only the values deselected during the event. The event can return a single value or an array if multiple values are deselected simultaneously.
        
            
              <mdb-form-control>
                <mdb-select
                (opened)="onSelectOpen()"
                (closed)="onSelectClose()"
                (valueChange)="onSelectValueChange($event)"
                (selected)="onSelectValueSelected($event)"
                (deselected)="onSelectValueDeselected($event)"
              >
                  <mdb-option *ngFor="let option of options" [value]="option.value"
                    >{{ option.label }}</mdb-option
                  >
                </mdb-select>
                <label mdbLabel class="form-label">Example label</label>
              </mdb-form-control>
            
        
    
        
            
              import { Component } from '@angular/core';

              @Component({
                selector: 'app-root',
                templateUrl: './app.component.html',
              })
              export class AppComponent {
                options = [
                  { value: '1', label: 'One' },
                  { value: '2', label: 'Two' },
                  { value: '3', label: 'Three' },
                  { value: '4', label: 'Four' },
                  { value: '5', label: 'Five' },
                  { value: '6', label: 'Six' },
                  { value: '7', label: 'Seven' },
                  { value: '8', label: 'Eigth' },
                ];

                onSelectOpen(): void {
                  console.log('select open');
                }

                onSelectClose(): void {
                  console.log('select close');
                }

                onSelectValueChange(event: any): void {
                  console.log('select value changed', event);
                }

                onSelectValueSelected(event: Event): void {
                  console.log('select value selected', event);
                }

                onSelectValueDeselected(event: Event): void {
                  console.log('select value deselected', event);
                }
              }
            
        
    

Methods

Name Description Example
close Manually close the component select.close()
open Manually open the component select.open()
        
            
              <mdb-form-control>
                <mdb-select #select>
                  <mdb-option *ngFor="let option of options" [value]="option.value">{{
                    option.label
                  }}</mdb-option>
                </mdb-select>
                <label mdbLabel class="form-label">Example label</label>
              </mdb-form-control>
            
        
    
        
            
              import { Component, ViewChild, AfterViewInit } from '@angular/core';
              import { MdbSelectComponent } from 'mdb-angular-ui-kit/select';

              @Component({
                selector: 'app-root',
                templateUrl: './app.component.html',
              })
              export class AppComponent implements AfterViewInit {
                @ViewChild('select', { static: true }) select!: MdbSelectComponent;

                options = [
                  { value: '1', label: 'One' },
                  { value: '2', label: 'Two' },
                  { value: '3', label: 'Three' },
                  { value: '4', label: 'Four' },
                  { value: '5', label: 'Five' },
                  { value: '6', label: 'Six' },
                  { value: '7', label: 'Seven' },
                  { value: '8', label: 'Eigth' },
                ];

                ngAfterViewInit(): void {
                  Promise.resolve().then(() => {
                    this.select.open();
                  });
                }
              }
            
        
    

CSS variables

As part of MDB’s evolving CSS variables approach, select now use local CSS variables for enhanced real-time customization. Values for the CSS variables are set via Sass, so Sass customization is still supported, too.

Select CSS variables are in different classes which belong to this component. To make it easier to use them, you can find below all of the used CSS variables.

        
            
        // .select-wrapper
        --#{$prefix}form-outline-select-arrow-color: #{$form-outline-select-arrow-color};
        --#{$prefix}form-outline-select-arrow-font-size: #{$form-outline-select-arrow-font-size};
        --#{$prefix}form-outline-select-arrow-top: #{$form-outline-select-arrow-top};
        --#{$prefix}form-outline-select-arrow-right: #{$form-outline-select-arrow-right};
        --#{$prefix}form-outline-select-valid-color: #{$form-outline-select-valid-color};
        --#{$prefix}form-outline-select-invalid-color: #{$form-outline-select-invalid-color};
        --#{$prefix}form-outline-select-clear-btn-color: #{$form-outline-select-clear-btn-color};
        --#{$prefix}form-outline-select-clear-btn-font-size: #{$form-outline-select-clear-btn-font-size};
        --#{$prefix}form-outline-select-clear-btn-top: #{$form-outline-select-clear-btn-top};
        --#{$prefix}form-outline-select-clear-btn-right: #{$form-outline-select-clear-btn-right};
        --#{$prefix}form-outline-select-clear-btn-focus-color: #{$form-outline-select-clear-btn-focus-color};
        --#{$prefix}form-outline-select-sm-clear-btn-font-size: #{$form-outline-select-sm-clear-btn-font-size};
        --#{$prefix}form-outline-select-sm-clear-btn-top: #{$form-outline-select-sm-clear-btn-top};
        --#{$prefix}form-outline-select-lg-clear-btn-top: #{$form-outline-select-lg-clear-btn-top};
        --#{$prefix}form-outline-select-label-max-width: #{$form-outline-select-label-max-width};
        --#{$prefix}form-outline-select-label-active-transform: #{$form-outline-select-label-active-transform};
        --#{$prefix}form-outline-select-lg-label-active-transform: #{$form-outline-select-lg-label-active-transform};
        --#{$prefix}form-outline-select-sm-label-active-transform: #{$form-outline-select-sm-label-active-transform};
        --#{$prefix}form-outline-select-input-focused-color: #{$form-outline-select-input-focused-color};
        --#{$prefix}form-outline-select-label-color: #{$form-outline-select-label-color};
        --#{$prefix}form-outline-select-notch-border-color: #{$form-outline-select-notch-border-color};
        --#{$prefix}form-outline-select-white-notch-border-color: #{$form-outline-select-white-notch-border-color};
        --#{$prefix}form-outline-select-input-focused-arrow-color: #{$form-outline-select-input-focused-arrow-color};
        --#{$prefix}form-outline-select-white-focus-arrow-color: #{$form-outline-select-white-focus-arrow-color};
        --#{$prefix}form-outline-select-white-arrow-color: #{$form-outline-select-white-arrow-color};
        --#{$prefix}form-outline-select-white-clear-btn: #{$form-outline-select-white-clear-btn};
        --#{$prefix}form-outline-select-sm-arrow-top: #{$form-outline-select-sm-arrow-top};
        --#{$prefix}form-outline-select-lg-arrow-top: #{$form-outline-select-lg-arrow-top};
        --#{$prefix}form-outline-form-notch-border-top: #{$form-outline-form-notch-border-top};
      
        // .select-dropdown-container
        --#{$prefix}form-outline-select-dropdown-container-z-index: #{$form-outline-select-dropdown-container-z-index};
        --#{$prefix}form-outline-select-dropdown-bg: #{$form-outline-select-dropdown-bg};
        --#{$prefix}form-outline-select-dropdown-box-shadow: #{$form-outline-select-dropdown-box-shadow};
        --#{$prefix}form-outline-select-dropdown-min-width: #{$form-outline-select-dropdown-min-width};
        --#{$prefix}form-outline-select-dropdown-transform: #{$form-outline-select-dropdown-transform};
        --#{$prefix}form-outline-select-dropdown-transition: #{$form-outline-select-dropdown-transition};
        --#{$prefix}form-outline-select-dropdown-open-transform: #{$form-outline-select-dropdown-open-transform};
        --#{$prefix}form-outline-select-dropdown-input-group-padding: #{$form-outline-select-dropdown-input-group-padding};
        --#{$prefix}form-outline-select-options-wrapper-scrollbar-width: #{$form-outline-select-options-wrapper-scrollbar-width};
        --#{$prefix}form-outline-select-options-wrapper-scrollbar-height: #{$form-outline-select-options-wrapper-scrollbar-height};
        --#{$prefix}form-outline-select-options-wrapper-scrollbar-border-bottom-right-radius: #{$form-outline-select-options-wrapper-scrollbar-border-bottom-right-radius};
        --#{$prefix}form-outline-select-options-wrapper-scrollbar-border-bottom-left-radius: #{$form-outline-select-options-wrapper-scrollbar-border-bottom-left-radius};
        --#{$prefix}form-outline-select-options-wrapper-scrollbar-thumb-height: #{$form-outline-select-options-wrapper-scrollbar-thumb-height};
        --#{$prefix}form-outline-select-options-wrapper-scrollbar-thumb-bg: #{$form-outline-select-options-wrapper-scrollbar-thumb-bg};
        --#{$prefix}form-outline-select-options-wrapper-scrollbar-thumb-border-radius: #{$form-outline-select-options-wrapper-scrollbar-thumb-border-radius};
      
        // .select-option-group-label
        --#{$prefix}form-outline-select-option-group-label-padding-left: #{$form-outline-select-option-group-label-padding-left};
        --#{$prefix}form-outline-select-option-group-label-padding-right: #{$form-outline-select-option-group-label-padding-right};
        --#{$prefix}form-outline-select-option-group-label-font-size: #{$form-outline-select-option-group-label-font-size};
        --#{$prefix}form-outline-select-option-group-label-font-weight: #{$form-outline-select-option-group-label-font-weight};
        --#{$prefix}form-outline-select-option-group-label-color: #{$form-outline-select-option-group-label-color};
      
        // .select-option-group > .select-option
        --#{$prefix}form-outline-select-option-group-select-option-padding-left: #{$form-outline-select-option-group-select-option-padding-left};
        
        // .select-option
        --#{$prefix}form-outline-select-option-color: #{$form-outline-select-option-color};
        --#{$prefix}form-outline-select-option-padding-left: #{$form-outline-select-option-padding-left};
        --#{$prefix}form-outline-select-option-padding-right: #{$form-outline-select-option-padding-right};
        --#{$prefix}form-outline-select-option-font-size: #{$form-outline-select-option-font-size};
        --#{$prefix}form-outline-select-option-font-weight: #{$form-outline-select-option-font-weight};
        --#{$prefix}form-outline-select-option-hover-not-disabled-bg: #{$form-outline-select-option-hover-not-disabled-bg};
        --#{$prefix}form-outline-select-option-active-bg: #{$form-outline-select-option-active-bg};
        --#{$prefix}form-outline-select-option-selected-active-bg: #{$form-outline-select-option-selected-active-bg};
        --#{$prefix}form-outline-select-option-selected-disabled-color: #{$form-outline-select-option-selected-disabled-color};
        --#{$prefix}form-outline-select-option-selected-bg: #{$form-outline-select-option-selected-bg};
        --#{$prefix}form-outline-select-option-disabled-color: #{$form-outline-select-option-disabled-color};
        --#{$prefix}form-outline-select-option-text-form-check-input-margin-right: #{$form-outline-select-option-text-form-check-input-margin-right};
        --#{$prefix}form-outline-select-option-secondary-text-font-size: #{$form-outline-select-option-secondary-text-font-size};
        --#{$prefix}form-outline-select-option-secondary-text-color: #{$form-outline-select-option-secondary-text-color};
        --#{$prefix}form-outline-select-option-icon-width: #{$form-outline-select-option-icon-width};
        --#{$prefix}form-outline-select-option-icon-height: #{$form-outline-select-option-icon-height};
        --#{$prefix}form-outline-select-no-results-padding-left: #{$form-outline-select-no-results-padding-left};
        --#{$prefix}form-outline-select-no-results-padding-right: #{$form-outline-select-no-results-padding-right};
        --#{$prefix}form-outline-select-white-arrow: #{$form-outline-select-white-arrow};
        
        
    

SCSS variables

        
            
        $form-outline-select-arrow-color: #000;
        $form-outline-select-arrow-font-size: 16px;
        $form-outline-select-arrow-top: 7px;
        $form-outline-select-arrow-right: 16px;
        
        $form-outline-select-valid-color: #00b74a;
        $form-outline-select-invalid-color: #f93154;
        
        $form-outline-select-clear-btn-color: #000;
        $form-outline-select-clear-btn-font-size: 1rem;
        $form-outline-select-clear-btn-top: 7px;
        $form-outline-select-clear-btn-right: 27px;
        $form-outline-select-clear-btn-focus-color: $primary;
        
        $form-outline-select-sm-clear-btn-font-size: 0.8rem;
        $form-outline-select-sm-clear-btn-top: 4px;
        
        $form-outline-select-lg-clear-btn-top: 11px;
        
        $form-outline-select-dropdown-container-z-index: $popconfirm-backdrop-zindex;
        
        $form-outline-select-dropdown-bg: #fff;
        $form-outline-select-dropdown-box-shadow: 0 2px 5px 0 rgba(0, 0, 0, 0.16),
          0 2px 10px 0 rgba(0, 0, 0, 0.12);
        $form-outline-select-dropdown-min-width: 100px;
        $form-outline-select-dropdown-transform: scaleY(0.8);
        $form-outline-select-dropdown-transition: all 0.2s;
        
        $form-outline-select-dropdown-open-transform: scaleY(1);
        
        $form-outline-select-dropdown-input-group-padding: 10px;
        
        $form-outline-select-label-max-width: 80%;
        $form-outline-select-label-active-transform: translateY(-1rem) translateY(0.1rem) scale(0.8);
        
        $form-outline-select-lg-label-active-transform: translateY(-1.25rem) translateY(0.1rem) scale(0.8);
        $form-outline-select-sm-label-active-transform: translateY(-0.83rem) translateY(0.1rem) scale(0.8);
        
        $form-outline-select-input-focused-color: #616161;
        
        $form-outline-select-label-color: $primary;
        $form-outline-form-notch-border-top: 1px solid transparent;
        
        $form-outline-select-notch-border-width: 2px;
        $form-outline-select-notch-border-color: $primary;
        $form-outline-select-white-notch-border-color: #fff;
        $form-outline-select-notch-transition: all 0.2s linear;
        
        $form-outline-select-input-focused-arrow-color: $primary;
        
        $form-outline-select-white-focus-arrow-color: #fff;
        $form-outline-select-white-arrow-color: #fff;
        $form-outline-select-white-clear-btn: #fff;
        
        $form-outline-select-sm-arrow-top: 3px;
        $form-outline-select-lg-arrow-top: 11px;
        
        $form-outline-select-options-wrapper-scrollbar-width: 4px;
        $form-outline-select-options-wrapper-scrollbar-height: 4px;
        $form-outline-select-options-wrapper-scrollbar-border-bottom-right-radius: 4px;
        $form-outline-select-options-wrapper-scrollbar-border-bottom-left-radius: 4px;
        $form-outline-select-options-wrapper-scrollbar-thumb-height: 50px;
        $form-outline-select-options-wrapper-scrollbar-thumb-bg: #999;
        $form-outline-select-options-wrapper-scrollbar-thumb-border-radius: 4px;
        
        $form-outline-select-option-group-label-padding-left: 16px;
        $form-outline-select-option-group-label-padding-right: 16px;
        $form-outline-select-option-group-label-font-size: 1rem;
        $form-outline-select-option-group-label-font-weight: 400;
        $form-outline-select-option-group-label-color: rgba(0, 0, 0, 0.54);
        
        $form-outline-select-option-group-select-option-padding-left: 26px;
        
        $form-outline-select-option-color: rgba(0, 0, 0, 0.87);
        $form-outline-select-option-padding-left: 16px;
        $form-outline-select-option-padding-right: 16px;
        $form-outline-select-option-font-size: 1rem;
        $form-outline-select-option-font-weight: 400;
        
        $form-outline-select-option-hover-not-disabled-bg: rgba(0, 0, 0, 0.048);
        $form-outline-select-option-active-bg: rgba(0, 0, 0, 0.048);
        $form-outline-select-option-selected-active-bg: rgba(0, 0, 0, 0.048);
        $form-outline-select-option-selected-disabled-color: #9e9e9e;
        $form-outline-select-option-selected-bg: rgba(0, 0, 0, 0.02);
        $form-outline-select-option-disabled-color: #9e9e9e;
        
        $form-outline-select-option-text-form-check-input-margin-right: 10px;
        
        $form-outline-select-option-secondary-text-font-size: 0.8rem;
        $form-outline-select-option-secondary-text-color: #6c757d;
        
        $form-outline-select-option-icon-width: 28px;
        $form-outline-select-option-icon-height: 28px;
        
        $form-outline-select-custom-content-padding: 16px;
        
        $form-outline-select-no-results-padding-left: 16px;
        $form-outline-select-no-results-padding-right: 16px;
        
        $form-outline-select-white-arrow: #fff;

Select
Vue Bootstrap 5 Select
Vue Select fields components are used for collecting user provided information from a list of options.
Note: Read the API tab to find all available options and advanced customization
Basic example
      Select options are added using v-model with the
      options argument. You can get selected values in two ways. The first is to filter
      the data given in v-model:options by a selected key. The second
      method is to use v-model:selected which is read-only and stores the currently
      selected options as a string (single select) or as an array (multiple select).
    
      Basic select behaves like a native one and by default marks the first available option as
      selected. To change this setting, easily set the
      preselect property to false.
    
        
            
            <template>
              <MDBSelect v-model:options="options1" v-model:selected="selected1" />
            </template>
          
        
    
        
            
            <script>
              import { MDBSelect } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              export default {
                components: {
                  MDBSelect
                },
                setup() {
                  const options1 = ref([
                    { text: "One", value: 1 },
                    { text: "Two", value: 2 },
                    { text: "Three", value: 3 },
                    { text: "Four", value: 4 },
                    { text: "Five", value: 5 },
                    { text: "Six", value: 6 },
                    { text: "Seven", value: 7 },
                    { text: "Eight", value: 8 }
                  ]);
                  const selected1 = ref("");
                  return {
                    options1,
                    selected1
                  };
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBSelect } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              const options1 = ref([
                { text: "One", value: 1 },
                { text: "Two", value: 2 },
                { text: "Three", value: 3 },
                { text: "Four", value: 4 },
                { text: "Five", value: 5 },
                { text: "Six", value: 6 },
                { text: "Seven", value: 7 },
                { text: "Eight", value: 8 }
              ]);
              const selected1 = ref([]);
            </script>
          
        
    
Multiselect
Add multiple property to the select component to activate multiple mode.
        
            
            <template>
              <MDBSelect
                v-model:options="options2"
                v-model:selected="selected2"
                multiple
                label="Example label"
              />
            </template>
          
        
    
        
            
            <script>
              import { MDBSelect } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              export default {
                components: {
                  MDBSelect
                },
                setup() {
                  const options2 = ref([
                    { text: "One", value: 1 },
                    { text: "Two", value: 2 },
                    { text: "Three", value: 3 },
                    { text: "Four", value: 4 },
                    { text: "Five", value: 5 },
                    { text: "Six", value: 6 },
                    { text: "Seven", value: 7 },
                    { text: "Eight", value: 8 }
                  ]);
                  const selected2 = ref([]);
                  return {
                    options2,
                    selected2
                  };
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBSelect } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              const options2 = ref([
                { text: "One", value: 1 },
                { text: "Two", value: 2 },
                { text: "Three", value: 3 },
                { text: "Four", value: 4 },
                { text: "Five", value: 5 },
                { text: "Six", value: 6 },
                { text: "Seven", value: 7 },
                { text: "Eight", value: 8 }
              ]);
              const selected2 = ref([]);
            </script>
          
        
    
Select with label
      It is possible to add select label by setting the
      label property.
    
        
            
            <template>
              <MDBSelect v-model:options="options3" label="Example label" />
            </template>
          
        
    
        
            
            <script>
              import { MDBSelect } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              export default {
                components: {
                  MDBSelect
                },
                setup() {
                  const options3 = ref([
                    { text: "One", value: 1 },
                    { text: "Two", value: 2 },
                    { text: "Three", value: 3 },
                    { text: "Four", value: 4 },
                    { text: "Five", value: 5 }
                  ]);
                  return {
                    options3
                  };
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBSelect } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              const options3 = ref([
                { text: "One", value: 1 },
                { text: "Two", value: 2 },
                { text: "Three", value: 3 },
                { text: "Four", value: 4 },
                { text: "Five", value: 5 }
              ]);
            </script>
          
        
    
Select with placeholder
      Use placeholder property to set placeholder for select input. The placeholder
      will be displayed when input is focused and no option is selected.
    
        
            
            <template>
              <MDBSelect
                v-model:options="options4"
                multiple
                placeholder="Example placeholder"
              />
            </template>
          
        
    
        
            
            <script>
              import { MDBSelect } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              export default {
                components: {
                  MDBSelect
                },
                setup() {
                  const options4 = ref([
                    { text: "One", value: 1 },
                    { text: "Two", value: 2 },
                    { text: "Three", value: 3 },
                    { text: "Four", value: 4 },
                    { text: "Five", value: 5 }
                  ]);
                  return {
                    options4
                  };
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBSelect } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              const options4 = ref([
                { text: "One", value: 1 },
                { text: "Two", value: 2 },
                { text: "Three", value: 3 },
                { text: "Four", value: 4 },
                { text: "Five", value: 5 }
              ]);
            </script>
          
        
    
Disabled select
Add disabled attribute to the select component to disable select input.
        
            
            <template>
              <MDBSelect
                v-model:options="options5"
                disabled
              />
            </template>
          
        
    
        
            
            <script>
              import { MDBSelect } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              
              export default {
                components: {
                  MDBSelect
                },
                setup() {
                  const options5 = ref([
                    { text: "One", value: 1 },
                    { text: "Two", value: 2 },
                    { text: "Three", value: 3 },
                    { text: "Four", value: 4 },
                    { text: "Five", value: 5 }
                  ]);
                  return {
                    options5
                  };
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBSelect } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              
              const options5 = ref([
                { text: "One", value: 1 },
                { text: "Two", value: 2 },
                { text: "Three", value: 3 },
                { text: "Four", value: 4 },
                { text: "Five", value: 5 }
              ]);
            </script>
          
        
    
Disabled options
Use disabled key on option element to disable specific option.
        
            
            <template>
              <MDBSelect v-model:options="options6" />
            </template>
          
        
    
        
            
            <script>
              import { MDBSelect } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              export default {
                components: {
                  MDBSelect
                },
                setup() {
                  const options6 = ref([
                    { text: "One", value: 1 },
                    { text: "Two", value: 2, disabled: true },
                    { text: "Three", value: 3, disabled: true },
                    { text: "Four", value: 4 },
                    { text: "Five", value: 5 }
                  ]);
                  return {
                    options6
                  };
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBSelect } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              interface Option6 {
                text: string | number;
                value?: string | number;
                disabled?: boolean;
              }
              const options6 = ref<Option6[]>([
                { text: "One", value: 1 },
                { text: "Two", value: 2, disabled: true },
                { text: "Three", value: 3, disabled: true },
                { text: "Four", value: 4 },
                { text: "Five", value: 5 }
              ]);
            </script>
          
        
    
Custom content
Custom content will be displayed at the end of the select dropdown.
        
            
            <template>
              <MDBSelect v-model:options="options9">
                <MDBBtn color="primary" size="sm">Save</MDBBtn>
              </MDBSelect>
            </template>
          
        
    
        
            
            <script>
              import { MDBSelect, MDBBtn } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              export default {
                components: {
                  MDBSelect,
                  MDBBtn
                },
                setup() {
                  const options9 = ref([
                    { text: "One", value: 1 },
                    { text: "Two", value: 2 },
                    { text: "Three", value: 3 },
                    { text: "Four", value: 4 },
                    { text: "Five", value: 5 }
                  ]);
                  return {
                    options9
                  };
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBSelect, MDBBtn } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              const options9 = ref([
                { text: "One", value: 1 },
                { text: "Two", value: 2 },
                { text: "Three", value: 3 },
                { text: "Four", value: 4 },
                { text: "Five", value: 5 }
              ]);
            </script>
          
        
    
Visible options
      Use visibleOptions property to change the number of options that will be
      displayed in the select dropdown without scrolling.
    
        
            
            <template>
              <MDBSelect v-model:options="options10" :visibleOptions="3" />
            </template>
          
        
    
        
            
            <script>
              import { MDBSelect } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              export default {
                components: {
                  MDBSelect
                },
                setup() {
                  const options10 = ref([
                    { text: "One", value: 1 },
                    { text: "Two", value: 2 },
                    { text: "Three", value: 3 },
                    { text: "Four", value: 4 },
                    { text: "Five", value: 5 }
                  ]);
                  return {
                    options10
                  };
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBSelect } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              const options10 = ref([
                { text: "One", value: 1 },
                { text: "Two", value: 2 },
                { text: "Three", value: 3 },
                { text: "Four", value: 4 },
                { text: "Five", value: 5 }
              ]);
            </script>
          
        
    
Secondary text
Add secondary-text key to the specific options to display secondary text.
        
            
            <template>
              <MDBSelect v-model:options="options11" :optionHeight="44" />
            </template>
          
        
    
        
            
            <script>
              import { MDBSelect } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              export default {
                components: {
                  MDBSelect
                },
                setup() {
                  const options11 = ref([
                    { text: "One", secondaryText: "Secondary text", value: 1 },
                    { text: "Two", secondaryText: "Secondary text", value: 2 },
                    { text: "Three", secondaryText: "Secondary text", value: 3 },
                    { text: "Four", secondaryText: "Secondary text", value: 4 },
                    { text: "Five", secondaryText: "Secondary text", value: 5 }
                  ]);
                  return {
                    options11
                  };
                }
              };
            </script>
          
        
    
        
            
          <script setup lang="ts">
            import { MDBSelect } from "mdb-vue-ui-kit";
            import { ref } from "vue";
            const options11 = ref([
              { text: "One", secondaryText: "Secondary text", value: 1 },
              { text: "Two", secondaryText: "Secondary text", value: 2 },
              { text: "Three", secondaryText: "Secondary text", value: 3 },
              { text: "Four", secondaryText: "Secondary text", value: 4 },
              { text: "Five", secondaryText: "Secondary text", value: 5 }
            ]);
          </script>
        
        
    
Search
Set filter property to enable options filtering.
        
            
            <template>
              <MDBSelect v-model:options="options12" filter />
            </template>
          
        
    
        
            
            <script>
              import { MDBSelect } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              export default {
                components: {
                  MDBSelect
                },
                setup() {
                  const options12 = ref([
                    { text: "One", value: 1 },
                    { text: "Two", value: 2 },
                    { text: "Three", value: 3 },
                    { text: "Four", value: 4 },
                    { text: "Five", value: 5 },
                    { text: "Six", value: 6 },
                    { text: "Seven", value: 7 },
                    { text: "Eight", value: 8 },
                    { text: "Nine", value: 9 },
                    { text: "Ten", value: 10 },
                  ]);
                  return {
                    options12
                  };
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBSelect } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              const options12 = ref([
                { text: "One", value: 1 },
                { text: "Two", value: 2 },
                { text: "Three", value: 3 },
                { text: "Four", value: 4 },
                { text: "Five", value: 5 },
                { text: "Six", value: 6 },
                { text: "Seven", value: 7 },
                { text: "Eight", value: 8 },
                { text: "Nine", value: 9 },
                { text: "Ten", value: 10 },
              ]);
            </script>
          
        
    
Select with search inside a modal
        
            
            <template>
              <MDBBtn color="primary" aria-controls="exampleModal" @click="modal1 = true">Launch demo modal</MDBBtn>
              <MDBModal id="modal" tabindex="-1" labelledby="modalLabel" v-model="modal1">
                <MDBModalHeader>
                  <MDBModalTitle id="modalLabel"> Modal title </MDBModalTitle>
                </MDBModalHeader>
                <MDBModalBody>
                  <MDBSelect v-model:options="options13" filter />
                </MDBModalBody>
                <MDBModalFooter>
                  <MDBBtn color="secondary" @click="modal1 = false">Close</MDBBtn>
                  <MDBBtn color="primary">Save changes</MDBBtn>
                </MDBModalFooter>
              </MDBModal>
            </template>
          
        
    
        
            
            <script>
              import {
                MDBSelect,
                MDBBtn,
                MDBModal,
                MDBModalHeader,
                MDBModalTitle,
                MDBModalBody,
                MDBModalFooter
              } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              export default {
                components: {
                  MDBSelect,
                  MDBBtn,
                  MDBModal,
                  MDBModalHeader,
                  MDBModalTitle,
                  MDBModalBody,
                  MDBModalFooter
                },
                setup() {
                  const options13 = ref([
                    { text: "One", value: 1 },
                    { text: "Two", value: 2 },
                    { text: "Three", value: 3 },
                    { text: "Four", value: 4 },
                    { text: "Five", value: 5 },
                    { text: "Six", value: 6 },
                    { text: "Seven", value: 7 },
                    { text: "Eight", value: 8 },
                    { text: "Nine", value: 9 },
                    { text: "Ten", value: 10 }
                  ]);
                  const modal1 = ref(false);
                  return {
                    options13,
                    modal1
                  };
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import {
                MDBSelect,
                MDBBtn,
                MDBModal,
                MDBModalHeader,
                MDBModalTitle,
                MDBModalBody,
                MDBModalFooter
              } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              const options13 = ref([
                { text: "One", value: 1 },
                { text: "Two", value: 2 },
                { text: "Three", value: 3 },
                { text: "Four", value: 4 },
                { text: "Five", value: 5 },
                { text: "Six", value: 6 },
                { text: "Seven", value: 7 },
                { text: "Eight", value: 8 },
                { text: "Nine", value: 9 },
                { text: "Ten", value: 10 }
              ]);
              const modal1 = ref(false);
            </script>
          
        
    
Option groups
It is possible to group options by using optgroup key.
        
            
            <template>
              <MDBSelect v-model:options="options14" />
            </template>
          
        
    
        
            
            <script>
              import { MDBSelect } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              export default {
                components: {
                  MDBSelect
                },
                setup() {
                  const options14 = ref([
                    { text: "Label 1", optgroup: true, disabled: true },
                    { text: "One", value: 1 },
                    { text: "Two", value: 2 },
                    { text: "Three", value: 3 },
                    { text: "Label 2", optgroup: true, disabled: true },
                    { text: "Four", value: 4 },
                    { text: "Five", value: 5 },
                    { text: "Six", value: 6 }
                  ]);
                  return {
                    options14
                  };
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBSelect } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              interface Option14 {
                text: string | number;
                value?: string | number;
                disabled?: boolean;
                optgroup?: boolean;
              }
              const options14 = ref<Option14[]>([
                { text: "Label 1", optgroup: true, disabled: true },
                { text: "One", value: 1 },
                { text: "Two", value: 2 },
                { text: "Three", value: 3 },
                { text: "Label 2", optgroup: true, disabled: true },
                { text: "Four", value: 4 },
                { text: "Five", value: 5 },
                { text: "Six", value: 6 }
              ]);
            </script>
          
        
    
Select with icons
Add icon property to the specific options to display the option icon.
        
            
            <template>
              <MDBSelect v-model:options="options15" />
            </template>
          
        
    
        
            
            <script>
              import { MDBSelect } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              export default {
                components: {
                  MDBSelect
                },
                setup() {
                  const options15 = ref([
                    {
                      text: "One",
                      value: 1,
                      icon: "https://mdbootstrap.com/img/Photos/Avatars/avatar-1.webp"
                    },
                    {
                      text: "Two",
                      value: 2,
                      icon: "https://mdbootstrap.com/img/Photos/Avatars/avatar-2.webp"
                    },
                    {
                      text: "Three",
                      value: 3,
                      icon: "https://mdbootstrap.com/img/Photos/Avatars/avatar-3.webp"
                    },
                    {
                      text: "Four",
                      value: 4,
                      icon: "https://mdbootstrap.com/img/Photos/Avatars/avatar-4.webp"
                    },
                    {
                      text: "Five",
                      value: 5,
                      icon: "https://mdbootstrap.com/img/Photos/Avatars/avatar-5.webp"
                    }
                  ]);
                  return {
                    options15
                  };
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBSelect } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              const options15 = ref([
                {
                  text: "One",
                  value: 1,
                  icon: "https://mdbootstrap.com/img/Photos/Avatars/avatar-1.webp"
                },
                {
                  text: "Two",
                  value: 2,
                  icon: "https://mdbootstrap.com/img/Photos/Avatars/avatar-2.webp"
                },
                {
                  text: "Three",
                  value: 3,
                  icon: "https://mdbootstrap.com/img/Photos/Avatars/avatar-3.webp"
                },
                {
                  text: "Four",
                  value: 4,
                  icon: "https://mdbootstrap.com/img/Photos/Avatars/avatar-4.webp"
                },
                {
                  text: "Five",
                  value: 5,
                  icon: "https://mdbootstrap.com/img/Photos/Avatars/avatar-5.webp"
                }
              ]);
            </script>
          
        
    
Validation
      Set isValidated and isValid properties to enable component
      validation. The validFeedback and invalidFeedback options allow to
      modify the validation messages. Validate method can be set on select's
      change
      event.
    
        
            
            <template>
              <MDBSelect
                v-model:options="options8"
                v-model:selected="selected8"
                clearButton
                :isValidated="isValidated"
                :isValid="isValid"
                required
                validFeedback="This value is valid"
                invalidFeedback="This value is invalid"
                @change="validate"
              />
              <MDBBtn
                @click="
                  validate();
                  isValidated = true;
                "
                color="primary"
                size="sm"
                class="mt-3"
              >
                Submit
              </MDBBtn>
            </template>
          
        
    
        
            
            <script>
              import { MDBSelect, MDBBtn } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              export default {
                components: {
                  MDBSelect,
                  MDBBtn
                },
                setup() {
                  const options8 = ref([
                    { text: "One", value: 1 },
                    { text: "Two", value: 2 },
                    { text: "Three", value: 3 },
                    { text: "Four", value: 4 },
                    { text: "Five", value: 5 }
                  ]);
                  const selected8 = ref("");
                  const isValidated = ref(false);
                  const isValid = ref(false);
                  const validate = () => {
                    if (selected8.value === "" || !selected8.value) {
                      isValid.value = false;
                    } else {
                      isValid.value = true;
                    }
                  };
                  return {
                    options8,
                    selected8,
                    isValid,
                    isValidated,
                    validate
                  };
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBSelect, MDBBtn } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              const options8 = ref([
                { text: "One", value: 1 },
                { text: "Two", value: 2 },
                { text: "Three", value: 3 },
                { text: "Four", value: 4 },
                { text: "Five", value: 5 }
              ]);
              const selected8 = ref("");
              const isValidated = ref(false);
              const isValid = ref(false);
              const validate = () => {
                if (selected8.value === "" || !selected8.value) {
                  isValid.value = false;
                } else {
                  isValid.value = true;
                }
              };
            </script>
          
        
    
      You can create custom rules and show the validation results via isValidated and isValid properties.
    
        
            
            <template>
              <MDBRow
                tag="form"
                class="g-3 needs-validation"
                novalidate
                @submit.prevent="checkFormPro"
              >
                <MDBCol col="12">
                  <MDBSelect
                    v-model:options="optionsValidation1"
                    v-model:selected="selectedValidation1"
                    :isValidated="isSelectValidated"
                    :isValid="isSelectValid"
                    clearButton
                    validFeedback="This value is valid"
                    invalidFeedback="This value is invalid"
                    @change="validateSelect"
                  />
                </MDBCol>
                <MDBCol col="12">
                  <MDBBtn color="primary" type="submit">Submit form</MDBBtn>
                </MDBCol>
              </MDBRow>
            </template>
          
        
    
        
            
            <script>
              import { MDBSelect, MDBBtn, MDBRow, MDBCol } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              export default {
                components: {
                  MDBSelect,
                  MDBBtn
                },
                setup() {
                  const optionsValidation1 = ref([
                    { text: "One", value: 1 },
                    { text: "Two", value: 2 },
                    { text: "Three", value: 3 },
                    { text: "Four", value: 4 },
                    { text: "Five", value: 5 },
                    { text: "Six", value: 6 },
                    { text: "Seven", value: 7 },
                    { text: "Eight", value: 8 },
                  ]);
                  const selectedValidation1 = ref();
                  const isSelectValidated = ref(false);
                  const isSelectValid = ref(false);
                  const validateSelect = () => {
                    if (!isSelectValidated.value) {
                      return;
                    }
                    isSelectValid.value =
                      optionsValidation1.value.filter(
                        (v) => v.value === selectedValidation1.value
                      ).length !== 0;
                  };
                  const checkFormPro = (e) => {
                    e.target.classList.add("was-validated");
                    isSelectValidated.value = true;
                    validateSelect();
                  };
                  return {
                    optionsValidation1,
                    selectedValidation1,
                    isSelectValidated,
                    isSelectValid,
                    validateSelect,
                    checkFormPro
                  };
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBSelect, MDBBtn, MDBRow, MDBCol } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              const optionsValidation1 = ref([
                { text: "One", value: 1 },
                { text: "Two", value: 2 },
                { text: "Three", value: 3 },
                { text: "Four", value: 4 },
                { text: "Five", value: 5 },
                { text: "Six", value: 6 },
                { text: "Seven", value: 7 },
                { text: "Eight", value: 8 },
              ]);
              const selectedValidation1 = ref();
              const isSelectValidated = ref(false);
              const isSelectValid = ref(false);
              const validateSelect = () => {
                if (!isSelectValidated.value) {
                  return;
                }
                isSelectValid.value =
                  optionsValidation1.value.filter(
                    (v) => v.value === selectedValidation1.value
                  ).length !== 0;
              };
              const checkFormPro = (e) => {
                e.target.classList.add("was-validated");
                isSelectValidated.value = true;
                validateSelect();
              };
            </script>
          
        
    
Set value
The setValue method allows to programatically set the component selections.
Single selection
Add single value string to the arguments list to correctly select option with corresponding value in single selection mode.
        
            
              <template>
                <MDBSelect
                  v-model:options="options16"
                  v-model:selected="selected16"
                  ref="select16"
                />
                <MDBBtn
                  class="mt-2"
                  color="primary"
                  size="sm"
                  @click="select16?.setValue(4)"
                >
                  Select four
                </MDBBtn>
              </template>
            
        
    
        
            
              <script>
                import { MDBSelect, MDBBtn } from "mdb-vue-ui-kit";
                import { ref } from "vue";
                export default {
                  components: {
                    MDBSelect,
                    MDBBtn
                  },
                  setup() {
                    const options16 = ref([
                      { text: "One", value: 1 },
                      { text: "Two", value: 2 },
                      { text: "Three", value: 3 },
                      { text: "Four", value: 4 },
                      { text: "Five", value: 5 },
                      { text: "Six", value: 6 },
                      { text: "Seven", value: 7 },
                      { text: "Eight", value: 8 }
                    ]);
                    const selected16 = ref("");
                    const select16 = ref(null); 
                    return {
                      options16,
                      selected16,
                      select16
                    };
                  }
                };
              </script>
            
        
    
        
            
              <script setup lang="ts">
                import { MDBSelect, MDBBtn } from "mdb-vue-ui-kit";
                import { ref } from "vue";
                const options16 = ref([
                  { text: "One", value: 1 },
                  { text: "Two", value: 2 },
                  { text: "Three", value: 3 },
                  { text: "Four", value: 4 },
                  { text: "Five", value: 5 },
                  { text: "Six", value: 6 },
                  { text: "Seven", value: 7 },
                  { text: "Eight", value: 8 }
                ]);
                const selected16 = ref("");
                
                const select16 = ref<InstanceType<typeof MDBSelect> | null>(null); 
              </script>
            
        
    
Multi selection
Add array of string values to the arguments list to correctly select options with corresponding values in multi selection mode.
        
            
              <template>
                <MDBSelect v-model:options="options17" v-model:selected="selected17" multiple ref="select17" />
                <MDBBtn class="mt-2" color="primary" size="sm" @click="select17?.setValue([3, 4, 5])">
                  Select three, four, five
                </MDBBtn>
              </template>
            
        
    
        
            
              <script>
                import { MDBSelect, MDBBtn } from "mdb-vue-ui-kit";
                import { ref } from "vue";
                export default {
                  components: {
                    MDBSelect,
                    MDBBtn
                  },
                  setup() {
                    const options17 = ref([
                      { text: "One", value: 1 },
                      { text: "Two", value: 2 },
                      { text: "Three", value: 3 },
                      { text: "Four", value: 4 },
                      { text: "Five", value: 5 },
                      { text: "Six", value: 6 },
                      { text: "Seven", value: 7 },
                      { text: "Eight", value: 8 }
                    ]);
                    const selected17 = ref("");
                    const select17 = ref(null);
                    return {
                      options17,
                      selected17,
                      select17
                    };
                  }
                };
              </script>
            
        
    
        
            
              <script setup lang="ts">
                import { MDBSelect, MDBBtn } from "mdb-vue-ui-kit";
                import { ref } from "vue";
                const options17 = ref([
                  { text: "One", value: 1 },
                  { text: "Two", value: 2 },
                  { text: "Three", value: 3 },
                  { text: "Four", value: 4 },
                  { text: "Five", value: 5 },
                  { text: "Six", value: 6 },
                  { text: "Seven", value: 7 },
                  { text: "Eight", value: 8 },
                ]);
                const selected17 = ref("");
                const select17 = ref<InstanceType<typeof MDBSelect> | null>(null);
              </script>
            
        
    
Select with toggle element
      If you want to toggle Select via button, you have to add toggle / open / close
      function from MDBSelect ref and pin her to this button.
    
        
            
          <template>
            <MDBBtn
              color="primary"
              class="mb-3"
              @click.stop="toggleElement?.open()"
              @touchstart.stop
              >Toggle Select</MDBBtn
            >
            <MDBSelect
              ref="toggleElement"
              v-model:options="options8"
              v-model:selected="selected8"
            />
          </template>
        
        
    
        
            
          <script>
            import { MDBSelect, MDBBtn } from "mdb-vue-ui-kit";
            import { ref } from "vue";
            export default {
              components: {
                MDBSelect,
                MDBBtn
              },
              setup() {
                const options8 = ref([
                  { text: "One", value: 1 },
                  { text: "Two", value: 2 },
                  { text: "Three", value: 3 },
                  { text: "Four", value: 4 },
                  { text: "Five", value: 5 }
                ]);
                const selected8 = ref("");
                const toggleElement = ref(null);
                return {
                  options8,
                  selected8,
                  toggleElement,
                };
              }
            };
          </script>
        
        
    
        
            
          <script setup lang="ts">
            import { MDBSelect, MDBBtn } from "mdb-vue-ui-kit";
            import { ref } from "vue";
            const options8 = ref([
                  { text: "One", value: 1 },
                  { text: "Two", value: 2 },
                  { text: "Three", value: 3 },
                  { text: "Four", value: 4 },
                  { text: "Five", value: 5 }
                ]);
            const selected8 = ref("");
            const toggleElement = ref<InstanceType<typeof MDBSelect> | null>(null);
          </script>
        
        
    
Auto select
      Set autoSelect option to true to enable selecting on Tab press.
    
        
            
                <template>
                  <MDBSelect v-model:options="options18" v-model:selected="selected18" autoSelect />
                </template>
              
        
    
        
            
                <script>
                  import { MDBSelect } from "mdb-vue-ui-kit";
                  import { ref } from "vue";
                  export default {
                    components: {
                      MDBSelect
                    },
                    setup() {
                      const options18 = ref([
                        { text: "One", value: 1 },
                        { text: "Two", value: 2 },
                        { text: "Three", value: 3 },
                        { text: "Four", value: 4 },
                        { text: "Five", value: 5 },
                        { text: "Six", value: 6 },
                        { text: "Seven", value: 7 },
                        { text: "Eight", value: 8 }
                      ]);
                      const selected18 = ref("");
                      return {
                        options18,
                        selected18
                      };
                    }
                  };
                </script>
              
        
    
        
            
                <script setup lang="ts">
                  import { MDBSelect } from "mdb-vue-ui-kit";
                  import { ref } from "vue";
                  const options18 = ref([
                    { text: "One", value: 1 },
                    { text: "Two", value: 2 },
                    { text: "Three", value: 3 },
                    { text: "Four", value: 4 },
                    { text: "Five", value: 5 },
                    { text: "Six", value: 6 },
                    { text: "Seven", value: 7 },
                    { text: "Eight", value: 8 }
                  ]);
                  const selected18 = ref("");
                </script>
              
        
    
Select - API
Import
        
            
          <script>
            import { MDBSelect } from "mdb-vue-ui-kit";
          </script>
        
        
    
Properties
| Property | Type | Default | Description | 
|---|---|---|---|
autocomplete | 
          String | - | 
          Provides the autocomplete attribute to the input element.  | 
        
autoSelect | 
          Boolean | false | 
          Enables auto selecting on Tab press | 
clearButton | 
          Boolean | false | 
          Adds clear button to the select input. | 
clearButtonLabel | 
          String | 'Clear selection' | 
          Changes aria label of clear button. | 
disabled | 
          Boolean | false | 
          Changes select input state to disabled. | 
displayedLabels | 
          Number | 5 | 
          The maximum number of comma-separated list of options displayed on the Multiselect. If a user selects more options than that value, the X options selected text will be displayed instead. If set to -1, the limit is off. | 
excludeOptGroupsInFilter | 
          Boolean | false | 
          
            Allows to exclude option groups labels from the filter. If set to true, the filter will search only in the options and not show the option groups labels.
           | 
        
filter | 
          Boolean | false | 
          Displays filter input that allow to search for specific option. | 
filterDebounce | 
          Number | 300 | 
          Adds delay to the options list updates when using filter input. Improves performance of the select with filter. | 
filterFn | 
          Function | - | 
          Allows to customize the filter function. The Function should take two arguments: data and searchValue. The data argument is an array of options. The searchValue argument is a string value of the filter input. The function should return an array of filtered options. 
           | 
        
invalidFeedback | 
          String |  | 
          
            The text which is displayed below the select when the
            isValidated property is true and isValid prop is false.
           | 
        
isValidated | 
          Boolean | false | 
          Marks select as validated. | 
isValid | 
          Boolean | false | 
          Marks select as valid. | 
label | 
          String |  | 
          Defines select input label. | 
multiple | 
          Boolean | false | 
          Enables multiple mode. | 
noResultsText | 
          String | "No results" | 
          The text that will be displayed when no option is found after using select filter. | 
optionHeight | 
          Number | 38 | 
          Height of the select option. Used to determine dropdown height and number of visible options. | 
optionsSelectedLabel | 
          String | "options selected" | 
          The text which is displayed on the Multiselect when there are more than 5 (default) options selected, e.g. 7 options selected | 
placeholder | 
          String |  | 
          Defines select input placeholder. | 
preselect | 
          Boolean | true | 
          
            Basic select behaves like a native one and by default marks the first available option
            as selected. To change this setting, easily set this property to false.
           | 
        
required | 
          Boolean | false | 
          Changes select input state to required. | 
searchPlaceholder | 
          String | "Search..." | 
          Changes placeholder of the select search input. | 
selectAll | 
          Boolean | true | 
          Displays select all option in multiselect dropdown. | 
selectAllLabel | 
          String | "Select all" | 
          Changes label of select all option. | 
size | 
          String |  | 
          
            Changes input size. Available options: sm, lg,
            default.
           | 
        
tag | 
          String | "div" | 
          Defines select wrapper tag. | 
tabindex | 
          Number | 0 | 
          Adds passing tabindex value also to input. | 
validFeedback | 
          String |  | 
          
            The text which is displayed below the select when the
            isValidated and isValid properties are true.
           | 
        
visibleOptions | 
          Number | 5 | 
          The maximum number of options which are visible in the select dropdown without scrolling. | 
v-model:options | 
          Array | Data array required to fill select component. | |
v-model:selected | 
          [String, Array, Number] | Readonly and reactive property for getting selected values. | |
white | 
          Boolean | false | 
          Adjust input colors for dark backgrounds. | 
Methods
| Name | Description | Example | 
|---|---|---|
clear | 
          Manually clears a selection | $refs.select1.clear(); | 
close | 
          Manually closes a select | $refs.select1.close(); | 
open | 
          Manually opens a select | $refs.select1.open(); | 
setValue | 
          Programatically set component selections. Add single value for default select and array of values for multiselect. | $refs.select1.setValue(3); | 
setOption | 
          
            Programatically set component selections by an option key. Use
            -1 key to select all in multiple mode.
           | 
          $refs.select1.setOption(2); | 
toggle | 
          Manually toggles a select | $refs.select1.toggle(); | 
toggleSelectAll | 
          Toggle select all. | $refs.select1.toggleSelectAll(); | 
        
            
          <template>
            <MDBSelect v-model:options="options1" ref="select1" />
            <MDBBtn @click.stop="select1?.setValue(3)" color="primary">
               Select three
            </MDBBtn >
          </template>
        
        
    
        
            
        <script>
          import { MDBSelect, MDBBtn } from "mdb-vue-ui-kit";
          import { ref } from "vue";
        
          export default {
            components: {
              MDBSelect,
              MDBBtn
            },
            setup() {
              const options1 = ref([
                { text: "One", value: 1 },
                { text: "Two", value: 2 },
                { text: "Three", value: 3 },
                { text: "Four", value: 4 },
                { text: "Five", value: 5 },
                { text: "Six", value: 6 },
                { text: "Seven", value: 7 },
                { text: "Eight", value: 8 }
              ]);
              const select1 = ref(null);
        
              return {
                options1,
                select1
              };
            }
          };
        </script>
        
        
    
        
            
        <script setup lang="ts">
          import { MDBSelect, MDBBtn } from "mdb-vue-ui-kit";
          import { ref } from "vue";
        
          const options1 = ref([
            { text: "One", value: 1 },
            { text: "Two", value: 2 },
            { text: "Three", value: 3 },
            { text: "Four", value: 4 },
            { text: "Five", value: 5 },
            { text: "Six", value: 6 },
            { text: "Seven", value: 7 },
            { text: "Eight", value: 8 }
          ]);
          const select1 = ref<InstanceType<typeof MDBSelect> | null>(null);
        </script>
        
        
    
Events
| Name | Description | 
|---|---|
change | 
          This event fires immediately on every select data change. | 
clear | 
          This event fires immediately when the select is cleared. | 
close | 
          This event fires immediately when the select is closed. | 
closed | 
          This event fires when the select is closed and animation finished. | 
open | 
          This event fires immediately when the select is opened. | 
opened | 
          This event fires after the select is opened. | 
search | 
          This event fires on input in search field. Information about the searched term can be accessed through the following property of the emitted event: e.value. | 
        
        
            
          <template>
            <MDBSelect v-model:options="options1" @clear="handleClear" />
          </template>
        
        
    
CSS variables
As part of MDB’s evolving CSS variables approach, select now use local CSS variables for enhanced real-time customization. Values for the CSS variables are set via Sass, so Sass customization is still supported, too.
Select CSS variables are in different classes which belong to this component. To make it easier to use them, you can find below all of the used CSS variables.
        
            
        // .select-wrapper
        --#{$prefix}form-outline-select-arrow-color: #{$form-outline-select-arrow-color};
        --#{$prefix}form-outline-select-arrow-font-size: #{$form-outline-select-arrow-font-size};
        --#{$prefix}form-outline-select-arrow-top: #{$form-outline-select-arrow-top};
        --#{$prefix}form-outline-select-arrow-right: #{$form-outline-select-arrow-right};
        --#{$prefix}form-outline-select-valid-color: #{$form-outline-select-valid-color};
        --#{$prefix}form-outline-select-invalid-color: #{$form-outline-select-invalid-color};
        --#{$prefix}form-outline-select-clear-btn-color: #{$form-outline-select-clear-btn-color};
        --#{$prefix}form-outline-select-clear-btn-font-size: #{$form-outline-select-clear-btn-font-size};
        --#{$prefix}form-outline-select-clear-btn-top: #{$form-outline-select-clear-btn-top};
        --#{$prefix}form-outline-select-clear-btn-right: #{$form-outline-select-clear-btn-right};
        --#{$prefix}form-outline-select-clear-btn-focus-color: #{$form-outline-select-clear-btn-focus-color};
        --#{$prefix}form-outline-select-sm-clear-btn-font-size: #{$form-outline-select-sm-clear-btn-font-size};
        --#{$prefix}form-outline-select-sm-clear-btn-top: #{$form-outline-select-sm-clear-btn-top};
        --#{$prefix}form-outline-select-lg-clear-btn-top: #{$form-outline-select-lg-clear-btn-top};
        --#{$prefix}form-outline-select-label-max-width: #{$form-outline-select-label-max-width};
        --#{$prefix}form-outline-select-label-active-transform: #{$form-outline-select-label-active-transform};
        --#{$prefix}form-outline-select-lg-label-active-transform: #{$form-outline-select-lg-label-active-transform};
        --#{$prefix}form-outline-select-sm-label-active-transform: #{$form-outline-select-sm-label-active-transform};
        --#{$prefix}form-outline-select-input-focused-color: #{$form-outline-select-input-focused-color};
        --#{$prefix}form-outline-select-label-color: #{$form-outline-select-label-color};
        --#{$prefix}form-outline-select-notch-border-color: #{$form-outline-select-notch-border-color};
        --#{$prefix}form-outline-select-white-notch-border-color: #{$form-outline-select-white-notch-border-color};
        --#{$prefix}form-outline-select-input-focused-arrow-color: #{$form-outline-select-input-focused-arrow-color};
        --#{$prefix}form-outline-select-white-focus-arrow-color: #{$form-outline-select-white-focus-arrow-color};
        --#{$prefix}form-outline-select-white-arrow-color: #{$form-outline-select-white-arrow-color};
        --#{$prefix}form-outline-select-white-clear-btn: #{$form-outline-select-white-clear-btn};
        --#{$prefix}form-outline-select-sm-arrow-top: #{$form-outline-select-sm-arrow-top};
        --#{$prefix}form-outline-select-lg-arrow-top: #{$form-outline-select-lg-arrow-top};
        --#{$prefix}form-outline-form-notch-border-top: #{$form-outline-form-notch-border-top};
      
        // .select-dropdown-container
        --#{$prefix}form-outline-select-dropdown-container-z-index: #{$form-outline-select-dropdown-container-z-index};
        --#{$prefix}form-outline-select-dropdown-bg: #{$form-outline-select-dropdown-bg};
        --#{$prefix}form-outline-select-dropdown-box-shadow: #{$form-outline-select-dropdown-box-shadow};
        --#{$prefix}form-outline-select-dropdown-min-width: #{$form-outline-select-dropdown-min-width};
        --#{$prefix}form-outline-select-dropdown-transform: #{$form-outline-select-dropdown-transform};
        --#{$prefix}form-outline-select-dropdown-transition: #{$form-outline-select-dropdown-transition};
        --#{$prefix}form-outline-select-dropdown-open-transform: #{$form-outline-select-dropdown-open-transform};
        --#{$prefix}form-outline-select-dropdown-input-group-padding: #{$form-outline-select-dropdown-input-group-padding};
        --#{$prefix}form-outline-select-options-wrapper-scrollbar-width: #{$form-outline-select-options-wrapper-scrollbar-width};
        --#{$prefix}form-outline-select-options-wrapper-scrollbar-height: #{$form-outline-select-options-wrapper-scrollbar-height};
        --#{$prefix}form-outline-select-options-wrapper-scrollbar-border-bottom-right-radius: #{$form-outline-select-options-wrapper-scrollbar-border-bottom-right-radius};
        --#{$prefix}form-outline-select-options-wrapper-scrollbar-border-bottom-left-radius: #{$form-outline-select-options-wrapper-scrollbar-border-bottom-left-radius};
        --#{$prefix}form-outline-select-options-wrapper-scrollbar-thumb-height: #{$form-outline-select-options-wrapper-scrollbar-thumb-height};
        --#{$prefix}form-outline-select-options-wrapper-scrollbar-thumb-bg: #{$form-outline-select-options-wrapper-scrollbar-thumb-bg};
        --#{$prefix}form-outline-select-options-wrapper-scrollbar-thumb-border-radius: #{$form-outline-select-options-wrapper-scrollbar-thumb-border-radius};
        --#{$prefix}form-outline-select-no-results-padding-left: #{$form-outline-select-no-results-padding-left};
        --#{$prefix}form-outline-select-no-results-padding-right: #{$form-outline-select-no-results-padding-right};
      
        // .select-option-group-label
        --#{$prefix}form-outline-select-option-group-label-padding-left: #{$form-outline-select-option-group-label-padding-left};
        --#{$prefix}form-outline-select-option-group-label-padding-right: #{$form-outline-select-option-group-label-padding-right};
        --#{$prefix}form-outline-select-option-group-label-font-size: #{$form-outline-select-option-group-label-font-size};
        --#{$prefix}form-outline-select-option-group-label-font-weight: #{$form-outline-select-option-group-label-font-weight};
        --#{$prefix}form-outline-select-option-group-label-color: #{$form-outline-select-option-group-label-color};
      
        // .select-option-group > .select-option
        --#{$prefix}form-outline-select-option-group-select-option-padding-left: #{$form-outline-select-option-group-select-option-padding-left};
        
        // .select-option
        --#{$prefix}form-outline-select-option-color: #{$form-outline-select-option-color};
        --#{$prefix}form-outline-select-option-padding-left: #{$form-outline-select-option-padding-left};
        --#{$prefix}form-outline-select-option-padding-right: #{$form-outline-select-option-padding-right};
        --#{$prefix}form-outline-select-option-font-size: #{$form-outline-select-option-font-size};
        --#{$prefix}form-outline-select-option-font-weight: #{$form-outline-select-option-font-weight};
        --#{$prefix}form-outline-select-option-hover-not-disabled-bg: #{$form-outline-select-option-hover-not-disabled-bg};
        --#{$prefix}form-outline-select-option-active-bg: #{$form-outline-select-option-active-bg};
        --#{$prefix}form-outline-select-option-selected-active-bg: #{$form-outline-select-option-selected-active-bg};
        --#{$prefix}form-outline-select-option-selected-disabled-color: #{$form-outline-select-option-selected-disabled-color};
        --#{$prefix}form-outline-select-option-disabled-color: #{$form-outline-select-option-disabled-color};
        --#{$prefix}form-outline-select-option-text-form-check-input-margin-right: #{$form-outline-select-option-text-form-check-input-margin-right};
        --#{$prefix}form-outline-select-option-secondary-text-font-size: #{$form-outline-select-option-secondary-text-font-size};
        --#{$prefix}form-outline-select-option-secondary-text-color: #{$form-outline-select-option-secondary-text-color};
        --#{$prefix}form-outline-select-option-icon-width: #{$form-outline-select-option-icon-width};
        --#{$prefix}form-outline-select-option-icon-height: #{$form-outline-select-option-icon-height};
        --#{$prefix}form-outline-select-white-arrow: #{$form-outline-select-white-arrow};
        --#{$prefix}form-outline-select-option-disabled-secondary-text-color: #{$form-outline-select-option-disabled-secondary-text-color};
        --#{$prefix}form-outline-select-option-selected-bg: #{$form-outline-select-option-selected-bg};
        --#{$prefix}form-outline-select-option-selected-hover-bg: #{$form-outline-select-option-selected-hover-bg};
        
        
    
SCSS variables
        
            
        $form-outline-select-arrow-color: var(--#{$prefix}surface-color);
        $form-outline-select-arrow-font-size: 16px;
        $form-outline-select-arrow-top: 7px;
        $form-outline-select-arrow-right: 16px;
        
        $form-outline-select-valid-color: #00b74a;
        $form-outline-select-invalid-color: #f93154;
        
        $form-outline-select-clear-btn-color: var(--#{$prefix}surface-color);
        $form-outline-select-clear-btn-font-size: 1rem;
        $form-outline-select-clear-btn-top: 7px;
        $form-outline-select-clear-btn-right: 27px;
        $form-outline-select-clear-btn-focus-color: $primary;
        
        $form-outline-select-sm-clear-btn-font-size: 0.8rem;
        $form-outline-select-sm-clear-btn-top: 4px;
        
        $form-outline-select-lg-clear-btn-top: 11px;
        
        $form-outline-select-dropdown-container-z-index: $popconfirm-backdrop-zindex;
        
        $form-outline-select-dropdown-bg: var(--#{$prefix}surface-bg);
        $form-outline-select-dropdown-box-shadow: 0 2px 5px 0 rgba(var(--#{$prefix}box-shadow-color-rgb), 0.16), 0 2px 10px 0 rgba(var(--#{$prefix}box-shadow-color-rgb), 0.12);
        $form-outline-select-dropdown-min-width: 100px;
        $form-outline-select-dropdown-transform: scaleY(0.8);
        $form-outline-select-dropdown-transition: all 0.2s;
        
        $form-outline-select-dropdown-open-transform: scaleY(1);
        
        $form-outline-select-dropdown-input-group-padding: 10px;
        
        $form-outline-select-label-max-width: 80%;
        $form-outline-select-label-active-transform: translateY(-1rem) translateY(0.1rem) scale(0.8);
        
        $form-outline-select-lg-label-active-transform: translateY(-1.25rem) translateY(0.1rem) scale(0.8);
        $form-outline-select-sm-label-active-transform: translateY(-0.83rem) translateY(0.1rem) scale(0.8);
        
        $form-outline-select-input-focused-color: var(--#{$prefix}surface-color);
        
        $form-outline-select-label-color: $primary;
        $form-outline-form-notch-border-top: 1px solid transparent;
        
        $form-outline-select-notch-border-width: 2px;
        $form-outline-select-notch-border-color: $primary;
        $form-outline-select-white-notch-border-color: #fff;
        $form-outline-select-notch-transition: all 0.2s linear;
        
        $form-outline-select-input-focused-arrow-color: $primary;
        
        $form-outline-select-white-focus-arrow-color: #fff;
        $form-outline-select-white-arrow-color: #fff;
        $form-outline-select-white-clear-btn: #fff;
        
        $form-outline-select-sm-arrow-top: 3px;
        $form-outline-select-lg-arrow-top: 11px;
        
        $form-outline-select-options-wrapper-scrollbar-width: 4px;
        $form-outline-select-options-wrapper-scrollbar-height: 4px;
        $form-outline-select-options-wrapper-scrollbar-border-bottom-right-radius: 4px;
        $form-outline-select-options-wrapper-scrollbar-border-bottom-left-radius: 4px;
        $form-outline-select-options-wrapper-scrollbar-thumb-height: 50px;
        $form-outline-select-options-wrapper-scrollbar-thumb-bg: var(--#{$prefix}scrollbar-thumb-bg);
        $form-outline-select-options-wrapper-scrollbar-thumb-border-radius: 4px;
        
        $form-outline-select-option-group-label-padding-left: 16px;
        $form-outline-select-option-group-label-padding-right: 16px;
        $form-outline-select-option-group-label-font-size: 1rem;
        $form-outline-select-option-group-label-font-weight: 400;
        $form-outline-select-option-group-label-color: rgba(var(--#{$prefix}emphasis-color-rgb), 0.55);
        
        $form-outline-select-option-group-select-option-padding-left: 26px;
        
        $form-outline-select-option-color: var(--#{$prefix}surface-color);
        $form-outline-select-option-padding-left: 16px;
        $form-outline-select-option-padding-right: 16px;
        $form-outline-select-option-font-size: 1rem;
        $form-outline-select-option-font-weight: 400;
        
        $form-outline-select-option-hover-not-disabled-bg: var(--#{$prefix}highlight-bg-color);
        $form-outline-select-option-active-bg: var(--#{$prefix}highlight-bg-color);
        $form-outline-select-option-selected-active-bg: rgba($primary, 0.45);
        $form-outline-select-option-selected-disabled-color: rgba(var(--#{$prefix}surface-color-rgb), 0.5);
        $form-outline-select-option-disabled-color: rgba(var(--#{$prefix}surface-color-rgb), 0.5);
        
        $form-outline-select-option-text-form-check-input-margin-right: 10px;
        
        $form-outline-select-option-secondary-text-font-size: 0.8rem;
        $form-outline-select-option-secondary-text-color: rgba(var(--#{$prefix}emphasis-color-rgb), 0.55);
        
        $form-outline-select-option-icon-width: 28px;
        $form-outline-select-option-icon-height: 28px;
        
        $form-outline-select-custom-content-padding: 16px;
        
        $form-outline-select-no-results-padding-left: 16px;
        $form-outline-select-no-results-padding-right: 16px;
        
        $form-outline-select-white-arrow: #fff;
        
        $form-outline-select-option-selected-bg: rgba($primary, 0.3);
        $form-outline-select-option-selected-hover-bg: $form-outline-select-option-selected-active-bg;
        $form-outline-select-option-disabled-secondary-text-color: rgba(var(--#{$prefix}emphasis-color-rgb), 0.3);

Select

React Bootstrap 5 Select

React Select fields components are used for collecting user provided information from a list of options.

Info: This documentation may contain syntax introduced in the MDB5 React 4.0.0 and can be incompatible with previous versions. For old MDBSelect documentation please follow the link.

Note: Read the API tab to find all available options and advanced customization


Basic example

Select fields components are used for collecting user provided information from a list of options.

Basic example of select component that allows you to choose from a number of options.

        
            
            import React from 'react';
            import { MDBSelect } from 'mdb-react-ui-kit';

            export default function App() {
              return (
                <MDBSelect
                  data={[
                    { text: 'One', value: 1 },
                    { text: 'Two', value: 2 },
                    { text: 'Three', value: 3 },
                    { text: 'Four', value: 4 },
                    { text: 'Five', value: 5 },
                    { text: 'Six', value: 6 },
                    { text: 'Seven', value: 7 },
                    { text: 'Eight', value: 8 },
                  ]}
                />
              );
            }
          
        
    

Multiselect

Add multiple property to the select element to activate multiple mode.

        
            
            import React from 'react';
            import { MDBSelect } from 'mdb-react-ui-kit';

            export default function App() {
              return (
                <MDBSelect
                  data={[
                    { text: 'One' },
                    { text: 'Two' },
                    { text: 'Three' },
                    { text: 'Four' },
                    { text: 'Five' },
                    { text: 'Six' },
                    { text: 'Seven' },
                    { text: 'Eight' },
                  ]}
                  multiple
                  label='Example label'
                />
              );
            }
          
        
    

Select with label

It is possible to add select label by setting the label property.

        
            
            import React from 'react';
            import { MDBSelect } from 'mdb-react-ui-kit';

            export default function App() {
              return (
                <MDBSelect
                  label='Example label'
                  data={[
                    { text: 'One', value: '1' },
                    { text: 'Two', value: '2' },
                    { text: 'Three', value: '3' },
                    { text: 'Four', value: '4' },
                    { text: 'Five', value: '5' },
                  ]}
                />
              );
            }
          
        
    

Select with placeholder

Use placeholder property to set placeholder for select input. The placeholder will be displayed when input is focused and no option is selected.

        
            
            import React from 'react';
            import { MDBSelect } from 'mdb-react-ui-kit';

            export default function App() {
              return (
                <MDBSelect
                  data={[
                    { text: '' },
                    { text: 'Two' },
                    { text: 'Three' },
                    { text: 'Four' },
                    { text: 'Five' },
                    { text: 'Six' },
                    { text: 'Seven' },
                    { text: 'Eight' },
                  ]}
                  placeholder='Example placeholder'
                />       
              );
            }
          
        
    

Disabled select

Add disabled attribute to the select component to disable select input.

        
            
            import React from 'react';
            import { MDBSelect } from 'mdb-react-ui-kit';

            export default function App() {
              return (
                <MDBSelect
                  data={[
                    { text: 'One' },
                    { text: 'Two' },
                    { text: 'Three' },
                    { text: 'Four' },
                    { text: 'Five' },
                    { text: 'Six' },
                    { text: 'Seven' },
                    { text: 'Eight' },
                  ]}
                  disabled
                />
              );
            }
          
        
    

Disabled options

Use disabled key on option element to disable specific option.

        
            
            import React from 'react';
            import { MDBSelect } from 'mdb-react-ui-kit';

            export default function App() {
              return (
                <MDBSelect
                  data={[
                    { text: 'One', value: 1 },
                    { text: 'Two', value: 2, disabled: true },
                    { text: 'Three', value: 3, disabled: true },
                    { text: 'Four', value: 4 },
                    { text: 'Five', value: 5 },
                    { text: 'Six', value: 6 },
                    { text: 'Seven', value: 7 },
                    { text: 'Eight', value: 8 },
                  ]}
                />
              );
            }
          
        
    

Clear button

Set clearButton property to display the button that will allow to clear current selections.

        
            
            import React from 'react';
            import { MDBSelect } from 'mdb-react-ui-kit';

            export default function App() {
              return (
                <MDBSelect
                  data={[
                    { text: 'One' },
                    { text: 'Two' },
                    { text: 'Three' },
                    { text: 'Four' },
                    { text: 'Five' },
                    { text: 'Six' },
                    { text: 'Seven' },
                    { text: 'Eight' },
                  ]}
                  clearBtn
                  label='Example label'
                />
              );
            }
          
        
    

Custom content

Custom content will be displayed at the end of the select dropdown.

        
            
            import React from 'react';
            import { MDBSelect, MDBBtn } from 'mdb-react-ui-kit';

            export default function App() {
              return (
                <MDBSelect data={[
                  { text: 'One' },
                  { text: 'Two' },
                  { text: 'Three' },
                  { text: 'Four', }
                ]}>
                  <MDBBtn size='sm'>Save</MDBBtn>
                </MDBSelect>
              );
            }
          
        
    

Visible options

Use visibleOptions property to change the number of options that will be displayed in the select dropdown without scrolling.

        
            
            import React from 'react';
            import { MDBSelect } from 'mdb-react-ui-kit';

            export default function App() {
              return (
                <MDBSelect
                  data={[
                    { text: 'One' },
                    { text: 'Two' },
                    { text: 'Three' },
                    { text: 'Four' },
                    { text: 'Five' },
                    { text: 'Six' },
                    { text: 'Seven' },
                    { text: 'Eight' },
                  ]}
                  visibleOptions={3}
                />
              );
            }
          
        
    

Secondary text

Add secondaryText key to the specific options to display secondary text.

        
            
            import React from 'react';
            import { MDBSelect } from 'mdb-react-ui-kit';

            export default function App() {
              return (
                <MDBSelect
                  data={[
                    { text: 'One', secondaryText: 'Secondary text' },
                    { text: 'Two', secondaryText: 'Secondary text' },
                    { text: 'Three', secondaryText: 'Secondary text' },
                    { text: 'Four', secondaryText: 'Secondary text' },
                  ]}
                />
              );
            }
          
        
    


Select with search inside a modal

        
            
            import React, { useState } from 'react';
            import {
              MDBBtn,
              MDBSelect,
              MDBModal,
              MDBModalDialog,
              MDBModalContent,
              MDBModalHeader,
              MDBModalTitle,
              MDBModalBody,
              MDBModalFooter,
            } from "mdb-react-ui-kit";

            export default function App() {
              const [basicModal, setBasicModal] = useState(false);

              const toggleShow = () => setBasicModal(!basicModal);

              return (
                <>
                  <MDBBtn onClick={toggleShow}>LAUNCH DEMO MODAL</MDBBtn>
                  <MDBModal show={basicModal} setShow={setBasicModal} tabIndex="-1">
                    <MDBModalDialog>
                      <MDBModalContent>
                        <MDBModalHeader>
                          <MDBModalTitle>Modal title</MDBModalTitle>
                          <MDBBtn
                            className="btn-close"
                            color="none"
                            onClick={toggleShow}
                          ></MDBBtn>
                        </MDBModalHeader>
                        <MDBModalBody>
                          {basicModal && (
                            <MDBSelect
                              search
                              data={[
                                { text: "One", value: 1 },
                                { text: "Two", value: 2 },
                                { text: "Three", value: 3 },
                                { text: "Four", value: 4 },
                                { text: "Five", value: 5 },
                                { text: "Six", value: 6 },
                                { text: "Seven", value: 7 },
                                { text: "Eight", value: 8 },
                                { text: "Nine", value: 9 },
                                { text: "Ten", value: 10 },
                              ]}
                            />
                          )}
                        </MDBModalBody>
        
                        <MDBModalFooter>
                          <MDBBtn color="secondary" onClick={toggleShow}>
                            Close
                          </MDBBtn>
                          <MDBBtn>Save changes</MDBBtn>
                        </MDBModalFooter>
                      </MDBModalContent>
                    </MDBModalDialog>
                  </MDBModal>
                </>
              );
            }
          
        
    

Select with icons

Add icon property to the specific options to display the option icon.

        
            
            import React from 'react';
            import { MDBSelect } from 'mdb-react-ui-kit';

            export default function App() {
              return (
                <MDBSelect
                  data={[
                    {
                      text: 'One',
                      icon: 'https://mdbootstrap.com/img/Photos/Avatars/avatar-1.webp',
                    },
                    {
                      text: 'Two',
                      icon: 'https://mdbootstrap.com/img/Photos/Avatars/avatar-2.webp',
                    },
                    {
                      text: 'Three',
                      icon: 'https://mdbootstrap.com/img/Photos/Avatars/avatar-3.webp',
                    },
                    {
                      text: 'Four',
                      icon: 'https://mdbootstrap.com/img/Photos/Avatars/avatar-4.webp',
                    },
                    {
                      text: 'Five',
                      icon: 'https://mdbootstrap.com/img/Photos/Avatars/avatar-5.webp',
                    },
                  ]}
                />
              );
            }
          
        
    

Validation

Set validation option to true to enable component validation. The validFeedback and invalidFeedback options allow to modify the validation messages.

        
            
            import React from 'react';
            import { MDBSelect, MDBValidation, MDBBtn } from 'mdb-react-ui-kit';

            export default function App() {
              return (
                <MDBValidation noValidate>
                  <MDBSelect
                    data={[
                      { text: 'One', value: 1 },
                      { text: 'Two', value: 2 },
                      { text: 'Three', value: 3 },
                      { text: 'Four', value: 4 },
                      { text: 'Five', value: 5 },
                      { text: 'Six', value: 6 },
                      { text: 'Seven', value: 7 },
                      { text: 'Eight', value: 8 },
                    ]}
                    clearBtn
                    validation
                    validFeedback='This value is valid'
                    invalidFeedback='This value is invalid'
                  />
                  <MDBBtn size='sm' className='mt-3' type='submit'>
                    Submit
                  </MDBBtn>
                </MDBValidation>
              );
            }
          
        
    

Controlled value

Set value prop to control the component value. The onValueChange event allows to handle the value change.


Single selection

For a standard single selection, type of the value should be a number.

        
            
              import React, { useState } from 'react';
              import { MDBSelect } from 'mdb-react-ui-kit';

              export default function App() {
                const [selectValue, setSelectValue] = useState(4);
                const [selectData, setSelectData] = useState([
                  { text: 'One', value: 1 },
                  { text: 'Two', value: 2 },
                  { text: 'Three', value: 3 },
                  { text: 'Four', value: 4 },
                  { text: 'Five', value: 5 },
                ]);

                return (
                  <MDBSelect
                    data={selectData}
                    label='Example label'
                    value={selectValue}
                    onValueChange={(e) => {
                      setSelectValue(e.value);
                    }}
                  />
                );
              }
            
        
    

Multi selection

For a multiselect, type of the value should be an array of numbers.

        
            
              import React, { useState } from 'react';
              import { MDBSelect } from 'mdb-react-ui-kit';

              export default function App() {
                const [selectValue, setSelectValue] = useState([3, 4, 5]);
                const [selectData, setSelectData] = useState([
                  { text: 'One', value: 1 },
                  { text: 'Two', value: 2 },
                  { text: 'Three', value: 3 },
                  { text: 'Four', value: 4 },
                  { text: 'Five', value: 5 },
                ]);

                return (
                  <MDBSelect
                    multiple
                    data={selectData}
                    label='Example label'
                    value={selectValue}
                    onValueChange={(e) => {
                      setSelectValue(e.value);
                    }}
                  />
                );
              }
            
        
    

Controlled open state

Set open property to control the component open state. The onOpen and onClose events allow to handle the open state change.

        
            
            import React, { useState } from 'react';
            import { MDBSelect } from 'mdb-react-ui-kit';

            export default function App() {
              const [selectOpen, setSelectOpen] = useState(false);

              return (
                <MDBSelect
                  data={[
                    { text: 'One', value: 1 },
                    { text: 'Two', value: 2 },
                    { text: 'Three', value: 3 },
                    { text: 'Four', value: 4 },
                    { text: 'Five', value: 5 },
                    { text: 'Six', value: 6 },
                    { text: 'Seven', value: 7 },
                    { text: 'Eight', value: 8 },
                  ]}
                  open={selectOpen}
                  onOpen={() => setSelectOpen(true)}
                  onClose={() => setSelectOpen(false)}
                />
              );
            }
          
        
    

Auto select

Set autoSelect option to true to enable selecting on Tab press.

        
            
            import React from 'react';
            import { MDBSelect } from 'mdb-react-ui-kit';

            export default function App() {
              return (
                <MDBSelect
                  autoSelect
                  data={[
                    { text: "One", value: 1 },
                    { text: "Two", value: 2 },
                    { text: "Three", value: 3 },
                    { text: "Four", value: 4 },
                    { text: "Five", value: 5 },
                    { text: "Six", value: 6 },
                    { text: "Seven", value: 7 },
                    { text: "Eight", value: 8 },
                    { text: "Nine", value: 9 },
                    { text: "Ten", value: 10 },
                  ]}
                />
              );
            }
          
        
    

Hidden selected option

Add the first option with the hidden and selected attributes and an empty value to leave select with no selection.

        
            
            import React from 'react';
            import { MDBSelect } from 'mdb-react-ui-kit';

            export default function App() {
              return (
                <MDBSelect
                  label="Example label"
                  data={[
                    { text: '', hidden: true },
                    { text: 'One', value: 1 },
                    { text: 'Two', value: 2 },
                    { text: 'Three', value: 3 },
                    { text: 'Four', value: 4 },
                    { text: 'Five', value: 5 },
                    { text: 'Six', value: 6 },
                    { text: 'Seven', value: 7 },
                    { text: 'Eight', value: 8 },
                  ]}
                />
              );
            }
              
        
    

Select with CSS classes

In order to use select with additional CSS classes you need to place it in the div wrapper and use CSS classes on that div. In case you use display classes like .d-lg-none and select is not visible on page load you need to use code from this example to update label width when select became visible.

        
            
              import React from 'react';
              import { MDBSelect } from 'mdb-react-ui-kit';

              export default function App() {
                return (
                  <MDBSelect
                  className="shadow-5"
                    data={[
                      { text: 'One', value: 1 },
                      { text: 'Two', value: 2 },
                      { text: 'Three', value: 3 },
                      { text: 'Four', value: 4 },
                      { text: 'Five', value: 5 },
                      { text: 'Six', value: 6 },
                      { text: 'Seven', value: 7 },
                      { text: 'Eight', value: 8 },
                    ]}
                  />
                );
              }
              
        
    

24H 00M 00S

Get one of the limited daily offers for AI Bundles with 98% OFF for our Black Days Sale!

Select - API


Import

        
            
            import { MDBSelect } from 'mdb-react-ui-kit';
          
        
    

Properties

MDBSelect

Name Type Default Description Example
autoSelect boolean false Enables auto selecting on Tab press <MDBSelect autoSelect />
animationVariants animationVariants?: {   open?: Record;   closed?: Record; }; { open: { opacity: 1, transform: 'scaleY(1)', transition: { duration: 0.2, }, }, closed: { opacity: 0, transform: 'scaleY(0.8)', transition: { duration: 0.2, }, }, } Defines animation variants <MDBSelect animationVariants={{ open: { height: 'auto', overflow: 'hidden' }, closed: { height: '0px' } }} />
value Array | string | number undefined Enables controlling selected options. Pass value of the option you want to choose, or array for multiselect. <MDBSelect value={multiselect ? [1, 2] : 1} />
open boolean undefined Enables controlling the open state. Typical use case expects handlers on onOpen and onClose events <MDBSelect open={isOpen} onOpen={() => setIsOpen(true)} />
clearBtn boolean false Add clear btn to MDBSelect <MDBSelect clearBtn />
contrast boolean false Adjust input colors for dark backgrounds <MDBSelect contrast />
data SelectData[] {} Add data to MDBSelect <MDBSelect data={[ { text: 'One', value: 1 } ]} />
disabled boolean false Disables MDBSelect component. Adds disabled to the input. <MDBSelect disabled />
displayedLabels number 5 The maximum number of comma-separated list of options displayed on the Multiselect. If a user selects more options than that value, the X options selected text will be displayed instead <MDBSelect displayedLabels={3} />
inputClassName string '' Add class to MDBSelect input element <MDBSelect inputClassName='test' />
invalidFeedback string '' Invalid feedback for MDBSelect <MDBSelect invalidFeedback='test' />
label string '' Add label to select <MDBSelect label='test' />
noResultsText string 'No results' Change text in option search if there is no records in search value. <MDBSelect noResultLabel="test" />
optionHeight number 38 Defines a height of the options (in px) <MDBSelect visibleOptions="3" />
optionsSelectedLabel string 'options selected' The text which is displayed on the Multiselect when there are more than 5 (default) options selected, e.g. 7 options selected <MDBSelect optionsSelectedLabel='options checked' />
placeholder string '' Add placeholder to MDBSelect <MDBSelect placeholder="test" />
preventFirstSelection boolean false Prevents selecting first option by default <MDBSelect preventFirstSelected />
search boolean false Add search to MDBSelect input in dropdown <MDBSelect search />
searchFn (query: string, data: ExtendedSelectData[]) => ExtendedSelectData[] - Customize search function <MDBSelect search searchFn={(query, data) => data.filter((opt) => opt.value == query)} />
searchLabel string 'Example Label' Change label of input <MDBSelect searchLabel="test" />
selectAll boolean true Displays select all option in multiselect dropdown <MDBSelect selectAll={false} />
selectAllLabel string 'Select all' Change label to select all option in multiselect <MDBSelect selectAllLabel="test" />
size 'default' | 'lg' | 'sm' 'default' Size of the MDBSelect <MDBSelect size='lg' />
multiple boolean false Change select to multiselect <MDBSelect multiple />
validation boolean false Enables validation for the MDBSelect <MDBSelect validation />
validFeedback string '' Valid feedback for MDBSelect <MDBSelect validFeedback='test' />
visibleOptions string | number '5' Change visible options in MDBSelect <MDBSelect visibleOptions="3" />

Advanced types

SelectData

        
                  
              type SelectData = {
                disabled?: boolean;
                hidden?: boolean;
                text?: string;
                defaultSelected?: boolean;
                secondaryText?: React.ReactNode;
                value?: string | number;
                icon?: string;
                active?: boolean;
                optgroup?: string;       
              };
            
        
    

Methods

Name Type Default Description Example
onChange (data: SelectData[] | SelectData) => void - This method returns a selected item in the MDBSelect or an array of items in multiple <MDBSelect onChange={(val) => setSelectValue(val)} />
onOpen () => void - Fires when the select demands to be opened. <MDBSelect onOpen={() => console.log('open')} />
onOpened () => void - Fires after select is opened. <MDBSelect onOpened={() => console.log('opened')} />
onClose () => void - Fires when the select demands to be closed. <MDBSelect onClose={() => console.log('close')} />
onClosed () => void - Fires after the select is closed. <MDBSelect onClose={() => console.log('closed')} />

CSS variables

As part of MDB’s evolving CSS variables approach, select now use local CSS variables for enhanced real-time customization. Values for the CSS variables are set via Sass, so Sass customization is still supported, too.

Select CSS variables are in different classes which belong to this component. To make it easier to use them, you can find below all of the used CSS variables.

        
            
        // .select-wrapper
        --#{$prefix}form-outline-select-arrow-color: #{$form-outline-select-arrow-color};
        --#{$prefix}form-outline-select-arrow-font-size: #{$form-outline-select-arrow-font-size};
        --#{$prefix}form-outline-select-arrow-top: #{$form-outline-select-arrow-top};
        --#{$prefix}form-outline-select-arrow-right: #{$form-outline-select-arrow-right};
        --#{$prefix}form-outline-select-valid-color: #{$form-outline-select-valid-color};
        --#{$prefix}form-outline-select-invalid-color: #{$form-outline-select-invalid-color};
        --#{$prefix}form-outline-select-clear-btn-color: #{$form-outline-select-clear-btn-color};
        --#{$prefix}form-outline-select-clear-btn-font-size: #{$form-outline-select-clear-btn-font-size};
        --#{$prefix}form-outline-select-clear-btn-top: #{$form-outline-select-clear-btn-top};
        --#{$prefix}form-outline-select-clear-btn-right: #{$form-outline-select-clear-btn-right};
        --#{$prefix}form-outline-select-clear-btn-focus-color: #{$form-outline-select-clear-btn-focus-color};
        --#{$prefix}form-outline-select-sm-clear-btn-font-size: #{$form-outline-select-sm-clear-btn-font-size};
        --#{$prefix}form-outline-select-sm-clear-btn-top: #{$form-outline-select-sm-clear-btn-top};
        --#{$prefix}form-outline-select-lg-clear-btn-top: #{$form-outline-select-lg-clear-btn-top};
        --#{$prefix}form-outline-select-label-max-width: #{$form-outline-select-label-max-width};
        --#{$prefix}form-outline-select-label-active-transform: #{$form-outline-select-label-active-transform};
        --#{$prefix}form-outline-select-lg-label-active-transform: #{$form-outline-select-lg-label-active-transform};
        --#{$prefix}form-outline-select-sm-label-active-transform: #{$form-outline-select-sm-label-active-transform};
        --#{$prefix}form-outline-select-input-focused-color: #{$form-outline-select-input-focused-color};
        --#{$prefix}form-outline-select-label-color: #{$form-outline-select-label-color};
        --#{$prefix}form-outline-select-notch-border-color: #{$form-outline-select-notch-border-color};
        --#{$prefix}form-outline-select-white-notch-border-color: #{$form-outline-select-white-notch-border-color};
        --#{$prefix}form-outline-select-input-focused-arrow-color: #{$form-outline-select-input-focused-arrow-color};
        --#{$prefix}form-outline-select-white-focus-arrow-color: #{$form-outline-select-white-focus-arrow-color};
        --#{$prefix}form-outline-select-white-arrow-color: #{$form-outline-select-white-arrow-color};
        --#{$prefix}form-outline-select-white-clear-btn: #{$form-outline-select-white-clear-btn};
        --#{$prefix}form-outline-select-sm-arrow-top: #{$form-outline-select-sm-arrow-top};
        --#{$prefix}form-outline-select-lg-arrow-top: #{$form-outline-select-lg-arrow-top};
        --#{$prefix}form-outline-form-notch-border-top: #{$form-outline-form-notch-border-top};
      
        // .select-dropdown-container
        --#{$prefix}form-outline-select-dropdown-container-z-index: #{$form-outline-select-dropdown-container-z-index};
        --#{$prefix}form-outline-select-dropdown-bg: #{$form-outline-select-dropdown-bg};
        --#{$prefix}form-outline-select-dropdown-box-shadow: #{$form-outline-select-dropdown-box-shadow};
        --#{$prefix}form-outline-select-dropdown-min-width: #{$form-outline-select-dropdown-min-width};
        --#{$prefix}form-outline-select-dropdown-transform: #{$form-outline-select-dropdown-transform};
        --#{$prefix}form-outline-select-dropdown-transition: #{$form-outline-select-dropdown-transition};
        --#{$prefix}form-outline-select-dropdown-open-transform: #{$form-outline-select-dropdown-open-transform};
        --#{$prefix}form-outline-select-dropdown-input-group-padding: #{$form-outline-select-dropdown-input-group-padding};
        --#{$prefix}form-outline-select-options-wrapper-scrollbar-width: #{$form-outline-select-options-wrapper-scrollbar-width};
        --#{$prefix}form-outline-select-options-wrapper-scrollbar-height: #{$form-outline-select-options-wrapper-scrollbar-height};
        --#{$prefix}form-outline-select-options-wrapper-scrollbar-border-bottom-right-radius: #{$form-outline-select-options-wrapper-scrollbar-border-bottom-right-radius};
        --#{$prefix}form-outline-select-options-wrapper-scrollbar-border-bottom-left-radius: #{$form-outline-select-options-wrapper-scrollbar-border-bottom-left-radius};
        --#{$prefix}form-outline-select-options-wrapper-scrollbar-thumb-height: #{$form-outline-select-options-wrapper-scrollbar-thumb-height};
        --#{$prefix}form-outline-select-options-wrapper-scrollbar-thumb-bg: #{$form-outline-select-options-wrapper-scrollbar-thumb-bg};
        --#{$prefix}form-outline-select-options-wrapper-scrollbar-thumb-border-radius: #{$form-outline-select-options-wrapper-scrollbar-thumb-border-radius};
      
        // .select-option-group-label
        --#{$prefix}form-outline-select-option-group-label-padding-left: #{$form-outline-select-option-group-label-padding-left};
        --#{$prefix}form-outline-select-option-group-label-padding-right: #{$form-outline-select-option-group-label-padding-right};
        --#{$prefix}form-outline-select-option-group-label-font-size: #{$form-outline-select-option-group-label-font-size};
        --#{$prefix}form-outline-select-option-group-label-font-weight: #{$form-outline-select-option-group-label-font-weight};
        --#{$prefix}form-outline-select-option-group-label-color: #{$form-outline-select-option-group-label-color};
      
        // .select-option-group > .select-option
        --#{$prefix}form-outline-select-option-group-select-option-padding-left: #{$form-outline-select-option-group-select-option-padding-left};
        
        // .select-option
        --#{$prefix}form-outline-select-option-color: #{$form-outline-select-option-color};
        --#{$prefix}form-outline-select-option-padding-left: #{$form-outline-select-option-padding-left};
        --#{$prefix}form-outline-select-option-padding-right: #{$form-outline-select-option-padding-right};
        --#{$prefix}form-outline-select-option-font-size: #{$form-outline-select-option-font-size};
        --#{$prefix}form-outline-select-option-font-weight: #{$form-outline-select-option-font-weight};
        --#{$prefix}form-outline-select-option-hover-not-disabled-bg: #{$form-outline-select-option-hover-not-disabled-bg};
        --#{$prefix}form-outline-select-option-active-bg: #{$form-outline-select-option-active-bg};
        --#{$prefix}form-outline-select-option-selected-active-bg: #{$form-outline-select-option-selected-active-bg};
        --#{$prefix}form-outline-select-option-selected-disabled-color: #{$form-outline-select-option-selected-disabled-color};
        --#{$prefix}form-outline-select-option-selected-bg: #{$form-outline-select-option-selected-bg};
        --#{$prefix}form-outline-select-option-disabled-color: #{$form-outline-select-option-disabled-color};
        --#{$prefix}form-outline-select-option-text-form-check-input-margin-right: #{$form-outline-select-option-text-form-check-input-margin-right};
        --#{$prefix}form-outline-select-option-secondary-text-font-size: #{$form-outline-select-option-secondary-text-font-size};
        --#{$prefix}form-outline-select-option-secondary-text-color: #{$form-outline-select-option-secondary-text-color};
        --#{$prefix}form-outline-select-option-icon-width: #{$form-outline-select-option-icon-width};
        --#{$prefix}form-outline-select-option-icon-height: #{$form-outline-select-option-icon-height};
        --#{$prefix}form-outline-select-no-results-padding-left: #{$form-outline-select-no-results-padding-left};
        --#{$prefix}form-outline-select-no-results-padding-right: #{$form-outline-select-no-results-padding-right};
        --#{$prefix}form-outline-select-white-arrow: #{$form-outline-select-white-arrow};
        
        
    

SCSS variables

        
            
        $form-outline-select-arrow-color: #000;
        $form-outline-select-arrow-font-size: 16px;
        $form-outline-select-arrow-top: 7px;
        $form-outline-select-arrow-right: 16px;
        
        $form-outline-select-valid-color: #00b74a;
        $form-outline-select-invalid-color: #f93154;
        
        $form-outline-select-clear-btn-color: #000;
        $form-outline-select-clear-btn-font-size: 1rem;
        $form-outline-select-clear-btn-top: 7px;
        $form-outline-select-clear-btn-right: 27px;
        $form-outline-select-clear-btn-focus-color: $primary;
        
        $form-outline-select-sm-clear-btn-font-size: 0.8rem;
        $form-outline-select-sm-clear-btn-top: 4px;
        
        $form-outline-select-lg-clear-btn-top: 11px;
        
        $form-outline-select-dropdown-container-z-index: $popconfirm-backdrop-zindex;
        
        $form-outline-select-dropdown-bg: #fff;
        $form-outline-select-dropdown-box-shadow: 0 2px 5px 0 rgba(0, 0, 0, 0.16),
          0 2px 10px 0 rgba(0, 0, 0, 0.12);
        $form-outline-select-dropdown-min-width: 100px;
        $form-outline-select-dropdown-transform: scaleY(0.8);
        $form-outline-select-dropdown-transition: all 0.2s;
        
        $form-outline-select-dropdown-open-transform: scaleY(1);
        
        $form-outline-select-dropdown-input-group-padding: 10px;
        
        $form-outline-select-label-max-width: 80%;
        $form-outline-select-label-active-transform: translateY(-1rem) translateY(0.1rem) scale(0.8);
        
        $form-outline-select-lg-label-active-transform: translateY(-1.25rem) translateY(0.1rem) scale(0.8);
        $form-outline-select-sm-label-active-transform: translateY(-0.83rem) translateY(0.1rem) scale(0.8);
        
        $form-outline-select-input-focused-color: #616161;
        
        $form-outline-select-label-color: $primary;
        $form-outline-form-notch-border-top: 1px solid transparent;
        
        $form-outline-select-notch-border-width: 2px;
        $form-outline-select-notch-border-color: $primary;
        $form-outline-select-white-notch-border-color: #fff;
        $form-outline-select-notch-transition: all 0.2s linear;
        
        $form-outline-select-input-focused-arrow-color: $primary;
        
        $form-outline-select-white-focus-arrow-color: #fff;
        $form-outline-select-white-arrow-color: #fff;
        $form-outline-select-white-clear-btn: #fff;
        
        $form-outline-select-sm-arrow-top: 3px;
        $form-outline-select-lg-arrow-top: 11px;
        
        $form-outline-select-options-wrapper-scrollbar-width: 4px;
        $form-outline-select-options-wrapper-scrollbar-height: 4px;
        $form-outline-select-options-wrapper-scrollbar-border-bottom-right-radius: 4px;
        $form-outline-select-options-wrapper-scrollbar-border-bottom-left-radius: 4px;
        $form-outline-select-options-wrapper-scrollbar-thumb-height: 50px;
        $form-outline-select-options-wrapper-scrollbar-thumb-bg: #999;
        $form-outline-select-options-wrapper-scrollbar-thumb-border-radius: 4px;
        
        $form-outline-select-option-group-label-padding-left: 16px;
        $form-outline-select-option-group-label-padding-right: 16px;
        $form-outline-select-option-group-label-font-size: 1rem;
        $form-outline-select-option-group-label-font-weight: 400;
        $form-outline-select-option-group-label-color: rgba(0, 0, 0, 0.54);
        
        $form-outline-select-option-group-select-option-padding-left: 26px;
        
        $form-outline-select-option-color: rgba(0, 0, 0, 0.87);
        $form-outline-select-option-padding-left: 16px;
        $form-outline-select-option-padding-right: 16px;
        $form-outline-select-option-font-size: 1rem;
        $form-outline-select-option-font-weight: 400;
        
        $form-outline-select-option-hover-not-disabled-bg: rgba(0, 0, 0, 0.048);
        $form-outline-select-option-active-bg: rgba(0, 0, 0, 0.048);
        $form-outline-select-option-selected-active-bg: rgba(0, 0, 0, 0.048);
        $form-outline-select-option-selected-disabled-color: #9e9e9e;
        $form-outline-select-option-selected-bg: rgba(0, 0, 0, 0.02);
        $form-outline-select-option-disabled-color: #9e9e9e;
        
        $form-outline-select-option-text-form-check-input-margin-right: 10px;
        
        $form-outline-select-option-secondary-text-font-size: 0.8rem;
        $form-outline-select-option-secondary-text-color: #6c757d;
        
        $form-outline-select-option-icon-width: 28px;
        $form-outline-select-option-icon-height: 28px;
        
        $form-outline-select-custom-content-padding: 16px;
        
        $form-outline-select-no-results-padding-left: 16px;
        $form-outline-select-no-results-padding-right: 16px;
        
        $form-outline-select-white-arrow: #fff;